; File Name   :	c:\user\hobby\hobby0\f83 fg forth\z1013\f83 1.3	bcb2.rom
; Format      :	Binary file
; Base Address:	0000h Range: 0200h - 2A20h Loaded length: 2820h

; F83 Version V1.3 Th. Beierlein 1988
; Anpassung Z1013 A.2 Andreas Driesel 1988
; Anpassung Z9001 VPohlers 1989
; reass. VPohlers 11/2010
; 27.04.2013 Beginn BIC-Version / 25.05.2013 mit Macros / 07.01.2020 Forth Code

		cpu	Z80


;sysver	 	equ	"Z1013"		; Z1013
;sysver	 	equ	"Z9001"		; Z9001
sysver		equ	"BIC"		; BIC, CP/M-Version, hnelt am ehesten der Version AIGV13.COM


;-----------------------------------------------------------------------------
; AS-Funktionen
;-----------------------------------------------------------------------------

; obere 8 Bit: hi(CONBU)
hi              function x,(x>>8)&255

; untere 8 Bit: lo(CONBU)
lo              function x, x&255

;------------------------------------------------------------------------------
; Makro fr Vokabulare
; die Link-Adressen werden in je 4 Variablen edlnk_xxx vorgehalten

	MACEXP_DFT noif,nomacro
	MACEXP_DFT off

voffs		eval	0

voc 	MACRO	NAME
		if "NAME"="FORTH"
voffs		eval	0
		elseif "NAME"="HIDDEN"
voffs		eval	4
		elseif "NAME"="IO"
voffs		eval	8
		elseif "NAME"="ASSEMBLER"
voffs		eval	0Ch
		elseif "NAME"="USER"
voffs		eval	10h
		elseif "NAME"="ROOT"
voffs		eval	14h
		elseif "NAME"="DOS"
voffs		eval	18h
		else
			error "unknown Voc NAME"
		endif
		ENDM

;------------------------------------------------------------------------------
; Makro fr FORTH-Header
; Aufruf:	header	EXEC,"EXECUTE"				( primitive )
;		header	COLON,":",DOCOL,IMMEDIATE		( Colon-Definition )

;Header-Aufbau LFA,NFA mit Namen,CFA,PFA

header		MACRO	LABL,NAME,CFA,HBITS,LFA
LABL_		label	$
lchar		eval charfromstr(NAME,0) & 03h + voffs; 2 Bit Hash
lcharx		eval "edlnk_\{lchar}"
		IFNDEF {lcharx}
{lcharx}	eval	0
		endif
		; LFA
		if "LFA"<>""
			dw	LFA
		else
			dw	{lcharx}
		endif
{lcharx}	eval	LABL_
		; NFA mit Namen, ggf. IMMEDIATE
		if "HBITS"<>""
			db	80h | StrLen(NAME) | HBITS
		else
			db	80h | StrLen(NAME)
		endif
		if StrLen(NAME)>1
			db	SubStr(NAME,0,StrLen(NAME)-1)
		endif
		db	charfromstr(NAME,StrLen(NAME)-1) | 80h
		; CFA
LABL		label	$
		if "CFA"<>""
			dw	CFA
		else
			dw	$+2	; primitive
		endif
		ENDM

IMMEDIATE	equ	1<<6		; Immediate-Bit

;------------------------------------------------------------------------------


; ab hier individuelle Anpassung an Z103

		if sysver == "Z1013"

		org 	200h

start:		ld	a, 0C3h		; jp
		ld	(18h), a	; eintragen von jp rst18
		ld	a, lo(rst18)	; auf 18h ff. (Ansprung von RST 18)
		ld	(19h), a
		ld	a, hi(rst18)
		ld	(1Ah), a
		jp	start1		; weiter zum eigentlichen Start

;
;------------------------------------------------------------------------------
; neue INKEY-Routine f. Z1013.A2, Ansprung ber RST 18
; vgl. INCH im Monitor A2
;------------------------------------------------------------------------------

		org start+40h

rst18:		push	ix
		ld	bc, 1000h
inc1:		push	bc
		rst	20h
		db    4			; INKEY
		pop	bc
		ld	ix, 4
		cp	(ix+0)
		jr	nz, inc6
		or	a
		jr	z, inc5
inc2:		dec	c
		jr	nz, inc2
		bit	4, (hl)
		jr	nz, inc4
		ld	de, 800h
inc3:		dec	de
		ld	a, e
		or	d
		jr	nz, inc3
inc4:		djnz	inc1
		set	4, (hl)
		xor	a
		jr	inc6
inc5:		res	4, (hl)
inc6:		ld	(ix+0),	a
		;;or	a		; in INCH-Routine des Monitors
		;;jr	z, inc1		; in INCH-Routine des Monitors
		pop	ix
		ret


; ab hier individuelle Anpassung an Z9001

		elseif sysver == "Z9001"

		org 	300h

		jp	start1
		db 	"F83     ",0
		jp	start2
		db 	"WF83    ",0
		db    	0

		endif

; freier Speicher fr eigenene Anpassungen ans System


;------------------------------------------------------------------------------
; Start des FORTH-Systems
;------------------------------------------------------------------------------

; ab hier individuelle Anpassung an Z1013

		if sysver == "Z1013"

		org	320h

origin:		nop
start1:		jp	cld
		nop
		jp	wrm
ostab:		jp	ci		; ofs 0 ;warte auf Tastaturbettigung
		jp	co		; ofs 3 ;Zeichenausgabe auf Console
		jp	csts		; ofs 6 ;True (-1), wenn Taste gedrckt, kein Warten
		jp	lo		; ofs 9 ;Zeichenausgabe auf Drucker
		rst	38h		; ofs 12 ;Sprung zum Betriebssytem
		rst	38h
		rst	38h

init_top:	dw 3400h		; top ;oberste vom FORTH nutzbare Adresse
init_sod:	dw 3400h		; sod ;erste Adresse, die die RAM-Disk belegen kann
init_eod:	dw 8000h		; eod ;letzte Adresse, die die RAM-Disk belegen kann

; origin+1DH - 0BFH    ;Platz fuer I/O-Anpassungen

		db 0FFh
		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; console output
; Zeichenausgabe auf Console
;------------------------------------------------------------------------------
co:		pop	hl
		push	bc
		push	iy
		ld	a, l
		call	co1
		pop	iy
		pop	bc
		jp	NEXT

		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; console input
; warte auf Tastaturbettigung
;------------------------------------------------------------------------------

ci:		push	bc
		push	iy
		rst	20h
		db    1			; INCH
		ld	h, 0
		ld	l, a
		pop	iy
		pop	bc
		jp	HPUSH

		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; console status
; True (-1), wenn Taste gedrckt, kein Warten
;------------------------------------------------------------------------------

csts:		push	bc
		push	iy
		rst	18h		; neue INKEY-Routine
		nop
		ld	h, 0
		ld	l, a
		pop	iy
		pop	bc
		jp	HPUSH

		db 0FFh
		db 0FFh

co1:		cp	0Ah
		ret	z
		rst	20h
		db    0
		ret

;------------------------------------------------------------------------------
; Konstante 6
; (als Patch f. XKEY)
;------------------------------------------------------------------------------

		header	SIX, "6", DOCON,,0FFFFh

		dw 6
;
		dw 0FFFFh

;------------------------------------------------------------------------------
; IM2-Interrupt-Tabelle
;------------------------------------------------------------------------------

;		align 2

isrtab:		dw isr1
		dw 0FFFFh
		dw 0FFFFh
		dw 0FFFFh

;------------------------------------------------------------------------------
; list output
;------------------------------------------------------------------------------

lo:		pop	hl
		ld	a, l
		out	(0), a
		ei
lo1:		jp	lo1

;------------------------------------------------------------------------------
; Interrupt-Routine
;------------------------------------------------------------------------------

isr1:		ld	hl, NEXT
		ex	(sp), hl
		reti

		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; cold start
;------------------------------------------------------------------------------

cld:		di
		im	2
		ld	a, hi(isrtab)
		ld	i, a
		ld	a, lo(isrtab)
		out	(1), a
		ld	a, 0Fh
		out	(1), a
		ld	a, 87h
		out	(1), a
		jp	cld1


; ...

; ab hier individuelle Anpassung an Z9001

		elseif sysver == "Z9001"

		org	320h

origin:		nop
start1:		jp	cld
start2:		nop
		jp	wrm
ostab:		jp	ci		; ofs 0 ;warte auf Tastaturbettigung
		jp	co		; ofs 3 ;Zeichenausgabe auf Console
		jp	csts		; ofs 6 ;True (-1), wenn Taste gedrckt, kein Warten
		jp	lo		; ofs 9 ;Zeichenausgabe auf Drucker
		jp	0		; ofs 12 ;Sprung zum Betriebssytem

init_top:	dw 6000h		; top ;oberste vom FORTH nutzbare Adresse
init_sod:	dw 6000h		; sod ;erste Adresse, die die RAM-Disk belegen kann
init_eod:	dw 0B07Fh		; eod ;letzte Adresse, die die RAM-Disk belegen kann

; origin+1DH - 0BFH    ;Platz fuer I/O-Anpassungen

		db 0B0h
		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; console output
; Zeichenausgabe auf Console
;------------------------------------------------------------------------------

co:		pop	hl
		push	bc
		push	iy
		ld	e, l
		ld	c, 2
		call	5
		pop	iy
		pop	bc
		jp	NEXT

;------------------------------------------------------------------------------
; console input
; warte	auf Tastaturbettigung
;------------------------------------------------------------------------------

ci:		push	bc
		push	iy
		ld	c, 1
		call	ci1
		ld	h, 0
		ld	l, a
		pop	iy
		pop	bc
		jp	HPUSH

;------------------------------------------------------------------------------
; console status
; True (-1), wenn Taste	gedrckt, kein Warten
;------------------------------------------------------------------------------

csts:		push	bc
		push	iy
		ld	c, 10
		call	5
		ld	h, 0
		ld	l, a
		pop	iy
		pop	bc
		jp	HPUSH

		db 0FFh
		db 0FFh
; ---------------------------------------------------------------------------

cld:		ld	hl, (36h)		; EOR
		ld	(init_eod), hl
		jp	cld1

		db 0FFh
		db 0FFh
		db 0FFh

;------------------------------------------------------------------------------
; list output
;------------------------------------------------------------------------------

lo:		pop	hl
		push	bc
		push	iy
		ld	e, l
		ld	c, 5
		call	5
		pop	iy
		pop	bc
		jp	NEXT

;------------------------------------------------------------------------------
; LIST-Erweiterung f. Zeicheneingabe
;------------------------------------------------------------------------------

ci1:		call	5
		cp	1Ch		; <LIST> ?
		ret	nz
		call	5
		ld	hl, lstab
		ld	b, 9
ci2:		cp	(hl)
		jr	z, ci3
		inc	hl
		djnz	ci2
		ret

ci3:		ld	a, 9
		add	a, l
		ld	l, a
		ld	a, (hl)
		ret

lstab:		db  32h	; 2
		db  38h	; 8
		db  34h	; 4
		db  39h	; 9
		db  36h	; 6
		db  33h	; 3
		db  37h	; 7
		db  35h	; 5
		db  31h	; 1

		db  60h	; `
		db  5Bh	; [
		db  5Ch	; backslash
		db  5Dh	; ]
		db  7Bh	; {
		db  7Ch	; |
		db  7Dh	; }
		db  7Eh	; ~
		db  7Fh	; 

; ...


; ab hier individuelle Anpassung an BIC

		elseif sysver == "BIC"

		org	100h		; CP/M

origin:		nop
start1:		jp	cld1
                nop
                jp      wrm
ostab:          jp      ci
                jp      co
                jp      csts
                jp      lo
                jp      retos
init_top:       dw 0A000h
init_sod:	dw 0A000h
init_eod:	dw 0C000h
                db 0FFh
                db 0FFh
                db 0FFh
; ---------------------------------------------------------------------------
                push    bc
                push    iy
                ld      c, 6
                ld      e, 0FFh
                call    5
                ld      l, a
                ld      h, 0
                pop     iy
                pop     bc
                jp      HPUSH
; ---------------------------------------------------------------------------
co:             pop     de
                push    bc
                push    iy
                ld      c, 6
                call    5
                pop     iy
                pop     bc
                jp      NEXT
; ---------------------------------------------------------------------------
                push    bc
                push    iy
                ld      c, 6
                ld      e, 0FFh
                call    5
                ld      hl, 0
                and     a
                jr      z, co1
                dec     hl
co1:            pop     iy
                pop     bc
                jp      HPUSH
; ---------------------------------------------------------------------------
lo:             pop     de
                push    bc
                push    iy
                ld      c, 5
                call    5
                pop     iy
                pop     bc
                jp      NEXT
; ---------------------------------------------------------------------------
                db    0
; ---------------------------------------------------------------------------
retos:          ld      c, 0
                call    5
                rst     38h
; ---------------------------------------------------------------------------
lastchar:        db 0                    ; letztes Zeichen von Console
; ---------------------------------------------------------------------------

csts:           push    bc
                push    iy
                ld      hl, lastchar    ; letztes Zeichen von Console
                ld      a, (hl)
                and     a
                jr      nz, csts1
                ld      c, 6
                ld      e, 0FFh
                push    hl
                call    5
                pop     hl
                ld      (hl), a
csts1:          and     a
                ld      hl, 0
                jr      z, csts2
                dec     hl
csts2:          pop     iy
                pop     bc
                jp      HPUSH
; ---------------------------------------------------------------------------
                db    0
; ---------------------------------------------------------------------------
ci:             ld      hl, lastchar    ; letztes Zeichen von Console
                ld      a, (hl)
                ld      (hl), 0
                ld      h, 0
                ld      l, a
                jp      HPUSH
; ---------------------------------------------------------------------------

;                ...

		endif



		org	origin+00C0h

;------------------------------------------------------------------------------
; User-Area
;------------------------------------------------------------------------------

INITR0:		dw 0			; 00 TOS
		dw 0			; 02 ENTRY
		dw 0			; 04 LINK
	if sysver == "Z9001"
		dw 5E00h-200		; 06 SP0	; s. cold
		dw 5E00h		; 08 RP0
		dw eof			; 0A DP
		dw 4			; 0C #OUT
		dw 0A74h		; 0E #LINE
		dw 0			; 10 OFFSET
		dw 10			; 12 BASE
		dw 2A52h		; 14 HLD
		dw 0			; 16 PRINTING
	elseif sysver == "BIC"
		dw 9C00h-200		; 06 SP0	; s. cold
		dw 9C00h		; 08 RP0
		dw eof			; 0A DP
		dw 1bh			; 0C #OUT
		dw 0349h		; 0E #LINE
		dw 0			; 10 OFFSET
		dw 10			; 12 BASE
		dw 3222h		; 14 HLD
		dw 0			; 16 PRINTING
	else
		dw 3200h-200		; 06 SP0	; s. cold
		dw 3200h		; 08 RP0
		dw eof			; 0A DP
		dw 4			; 0C #OUT
		dw 096Ah		; 0E #LINE
		dw 0			; 10 OFFSET
		dw 10			; 12 BASE
		dw 2A50h		; 14 HLD
		dw 0			; 16 PRINTING
	endif		
; Vektoren
		dw XEMIT		; 18 EMIT 	Vektor
	if sysver == "Z1013"
		dw XCR			; 1A CR		Vektor
	elseif sysver == "Z9001"
		dw XCR			; 1A CR		Vektor
	else
		dw CRLF			; 1A CR		Vektor	
	endif
		dw 0FFFFh
		dw 0FFFFh
		dw 0FFFFh
		dw 0FFFFh
		dw 0FFFFh
		dw 0FFFFh
		dw 0FFFFh
		dw 0FFFFh
		dw 0FFFFh
		dw 0FFFFh
		dw 0FFFFh
		dw 0FFFFh
		dw 0FFFFh
		dw 0FFFFh
		dw 0FFFFh
		dw 0FFFFh
		dw 0FFFFh
		dw 0FFFFh


;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------
;
;	FORTH REGISTERS
;
;	FORTH	8080	FORTH PRESERVATION RULES
;	-----	----	--------------------------------------
;			  FORTH WORDS
;	W	DE	SOMETIMES OUTPUT FROM NEXT
;			MAY BE ALTERED BEFORE JMP'ING TO NEXT
;			INPUT ONLY WHEN 'DPUSH' CALLED
;	SP	SP	SHOULD BE USED ONLY AS DATA STACK
;			  ACROSS FORTH WORDS
;			MAY BE USED WITHIN FORTH WORDS
;			  IF RESTORED BEFORE 'NEXT'
;		HL	NEVER OUTPUT FROM NEXT
;			INPUT ONLY WHEN 'HPUSH' CALLED
;	IP	BC	instruction pointer
;
;	UP	-	USER AREA POINTER (forth variable UPVAR)
;	RP	IY	RETURN STACK POINTER
;
;------------------------------------------------------
;
;	COMMENT CONVENTIONS:
;
;	=	MEANS	"IS EQUAL TO"
;	<-	MEANS	ASSIGNMENT
;
;	NAME	=	ADDRESS OF NAME
;	(NAME)	=	CONTENTS AT NAME
;	((NAME))=	INDIRECT CONTENTS
;
;	CFA	=	ADDRESS OF CODE FIELD
;	LFA	=	ADDRESS OF LINK FIELD
;	NFA	=	ADDR OF START OF NAME FIELD
;	PFA	=	ADDR OF START OF PARAMETER FIELD
;
;	S1	=	ADDR OF 1ST WORD OF PARAMETER STACK
;	S2	=	ADDR OF 2ND WORD OF PARAMETER STACK
;	R1	=	ADDR OF 1ST WORD OF RETURN STACK
;	R2	=	ADDR OF 2ND WORD OF RETURN STACK
;	( ABOVE STACK POSITIONS VALID BEFORE & AFTER EXECUTION
;	OF ANY WORD, NOT DURING. )
;
;	LSB	=	LEAST SIGNIFICANT BIT
;	MSB	=	MOST SIGNIFICANT BIT
;	LB	=	LOW BYTE
;	HB	=	HIGH BYTE
;	LW	=	LOW WORD
;	HW	=	HIGH WORD
;	( MAY BE USED AS SUFFIX TO ABOVE NAMES )
;
; in eigenen Primitives darf BC und IY nicht verndert werden!
;
;------------------------------------------------------
;
;	DICTIONARY FORMAT:
;
;				BYTE
;	ADDRESS	NAME		CONTENTS
;	------- ----		--------
;	LFA	LINK FIELD	<LINKLB>  = PREVIOUS WORD'S LFA
;				<LINKHB>
;					  ( MSB=1
;					  ( P=PRECEDENCE BIT
;					  ( S=SMUDGE BIT
;	NFA	NAME FIELD	1PS<LEN>  < NAME LENGTH
;				0<1CHAR>  MSB=0, NAME'S 1ST CHAR
;				0<2CHAR>
;				  ...
;				1<LCHAR>  MSB=1, NAME'S LAST CHR
;LABEL:	CFA	CODE FIELD	<CODELB>  = ADDR CPU CODE
;				<CODEHB>
;	PFA	PARAMETER	<1PARAM>  1ST PARAMETER BYTE
;		FIELD		<2PARAM>
;				  ...

		org	origin+0100h

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------
;	NEXT, THE FORTH ADDRESS INTERPRETER
;	  ( POST INCREMENTING VERSION )
;
DPUSH:		push	de
HPUSH:		push	hl
NEXT:		ld	a, (bc)		;(W) <- ((IP))
		inc	bc		;(IP) <- (IP)+2
		ld	l, a
		ld	a, (bc)
		inc	bc
		ld	h, a		; (HL) <- CFA
		ld	e, (hl)		;(PC) <- ((W))
		inc	hl
		ld	d, (hl)
		ex	de, hl
		jp	(hl)		; NOTE: (DE) = CFA+1

;------------------------------------------------------------------------------
; FORTH
; VOCABULARY FORTH
; FORTH DEFINITIONS
;------------------------------------------------------------------------------

; Vokabulare sind mit Hash-Faeden verkettet.
; Die Hash-Funktion ist der erste Buchstabe Modulo 3 (s. HASH)
; Der 5. Parameter ist die verkette Liste der Vokabulare (s. VOC-LINK)

		voc FORTH
		header VFORTH, "FORTH",DOVOC,,0

VFORTH1:	dw lstlnk_0	;00=@DHLPTX
		dw lstlnk_1	;01=AEIMQUY
		dw lstlnk_2	;10=BFJNRVZ
		dw lstlnk_3	;11=CGKOSW[
VFORTHL:	dw 0

;------------------------------------------------------------------------------
; HIDDEN
;------------------------------------------------------------------------------

		header VHIDDEN, "HIDDEN",DOVOC

		dw lstlnk_4
		dw lstlnk_5
		dw lstlnk_6
		dw lstlnk_7
VHIDDENL:	dw VFORTHL

;------------------------------------------------------------------------------
; Exec-Code f. Colon-Definitionen
;------------------------------------------------------------------------------

DOCOL:		dec	iy		; (R1) <- (IP)
		ld	(iy+0),	b
		dec	iy		; (RP) <- (RP) - 2
		ld	(iy+0),	c
		inc	de		; (DE) <- CFA+2 = (W)
		ld	b, d		; (IP) <- (DE) = (W)
		ld	c, e
		jp	NEXT

;------------------------------------------------------------------------------
; EXIT
;------------------------------------------------------------------------------

		header	EXIT, "EXIT"

EXIT1:		ld	c, (iy+0)	; (IP) <- (R1)
		inc	iy
		ld	b, (iy+0)
		inc	iy		; (RP) <- (RP) + 2
		jp	NEXT

;------------------------------------------------------------------------------
; UNNEST
;------------------------------------------------------------------------------

		voc HIDDEN
		header	UNNEST, "UNNEST", EXIT1

;------------------------------------------------------------------------------
; Exec-Code f. DOES
;------------------------------------------------------------------------------

DODOE:		dec	iy		; (R1) <- (IP) = PFA = (SUBSTITUTE CFA)
		ld	(iy+0),	b
		dec	iy		; (RP) <- (RP) - 2
		ld	(iy+0),	c
		pop	bc
		inc	de		; (DE) <- PFA = (SUBSTITUTE CFA)
		push	de		; (S1) <- PFA+2 = SUBSTITUTE PFA
		jp	NEXT

;------------------------------------------------------------------------------
; Exec-Code f. Variablen
;------------------------------------------------------------------------------

DOVAR:		inc	de
		push	de
		jp	NEXT

;------------------------------------------------------------------------------
; UP
;------------------------------------------------------------------------------

		voc FORTH
		header	UP, "UP", DOVAR

UPVAR:		dw INITR0		; User-Area

;------------------------------------------------------------------------------
; Exec-Code f. Konstanten
;------------------------------------------------------------------------------

DOCON:		inc	de		; (DE) <- PFA
		ex	de, hl
		ld	e, (hl)		; (DE) <- (PFA)
		inc	hl
		ld	d, (hl)
		push	de		; (S1) <- (PFA)
		jp	NEXT

;------------------------------------------------------------------------------
; Exec-Code f. Uservariablen
;------------------------------------------------------------------------------
DOUSE:		inc	de		; (DE) <- PFA
		ex	de, hl
		ld	e, (hl)		; (DE) <- USER VARIABLE OFFSET
		ld	d, 0
		ld	hl, (UPVAR)	; (HL) <- USER VARIABLE BASE ADDR
		add	hl, de		; (HL) <- (HL) + (DE)
		jp	HPUSH		; (S1) <- BASE + OFFSET

;------------------------------------------------------------------------------
; (LIT)
;------------------------------------------------------------------------------

		voc HIDDEN
		header	XLIT, "(LIT)"

		ld	a, (bc)		; (HL) <- ((IP)) = LITERAL
		inc	bc		; (IP) <- (IP) + 2
		ld	l, a		; LB
		ld	a, (bc)		; HB
		inc	bc
		ld	h, a
		jp	HPUSH		; (S1) <- (HL)

;------------------------------------------------------------------------------
; BRANCH
;------------------------------------------------------------------------------

		header	BRANCH, "BRANCH"

BRANCH0:	ld	h, b		; (HL) <- (IP)
		ld	l, c
		ld	c, (hl)		; (IP) <- ((IP)) = BRANCH ADDR
		inc	hl
		ld	b, (hl)
		jp	NEXT

;------------------------------------------------------------------------------
; ?BRANCH
;------------------------------------------------------------------------------

		header	QBRANCH, "?BRANCH"

		pop	hl
		ld	a, h
		or	l
		jp	z, BRANCH0
		inc	bc
		inc	bc
		jp	NEXT

;------------------------------------------------------------------------------
; (LOOP)
;------------------------------------------------------------------------------

		header	XLOOP, "(LOOP)"

		ld	de, 1
XLOOP1:		ld	l, (iy+0)
		ld	h, (iy+1)
		or	a
		adc	hl, de
		ld	(iy+0),	l
		ld	(iy+1),	h
		jp	po, BRANCH0
		ld	de, 6
		add	iy, de
		inc	bc
		inc	bc
		jp	NEXT

;------------------------------------------------------------------------------
; (+LOOP)
;------------------------------------------------------------------------------

		header	XPLOOP, "(+LOOP)"

		pop	de
		jp	XLOOP1

;------------------------------------------------------------------------------
; (DO)
;------------------------------------------------------------------------------

		header	XDO, "(DO)"

		pop	hl
		pop	de
XDO1:		dec	iy
		dec	iy
		ld	a, (bc)
		ld	(iy+0),	a
		inc	bc
		ld	a, (bc)
		ld	(iy+1),	a
		inc	bc
		ld	a, 80h ; ''
		add	a, d
		ld	d, a
		dec	iy
		ld	(iy+0),	d
		dec	iy
		ld	(iy+0),	e
		or	a
		sbc	hl, de
		dec	iy
		ld	(iy+0),	h
		dec	iy
		ld	(iy+0),	l
		jp	NEXT

;------------------------------------------------------------------------------
; (?DO)
;------------------------------------------------------------------------------

		header	XQDO, "(?DO)"

		pop	hl
		pop	de
		ld	a, h
		cp	d
		jp	nz, XDO1
		ld	a, l
		cp	e
		jp	nz, XDO1
		ld	h, b
		ld	l, c
		ld	c, (hl)
		inc	hl
		ld	b, (hl)
		jp	NEXT

;------------------------------------------------------------------------------
; >NEXT
;------------------------------------------------------------------------------

		voc FORTH
		header	TONEXT, ">NEXT",DOCON

		dw NEXT

;------------------------------------------------------------------------------
; EXECUTE
;------------------------------------------------------------------------------

		header	EXECUTE, "EXECUTE"

		pop	hl
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		ex	de, hl
		jp	(hl)

;------------------------------------------------------------------------------
; Exec-Code f. Vektoren
;------------------------------------------------------------------------------

DOVEC:		ex	de, hl
		inc	hl
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		ex	de, hl
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		ex	de, hl
		jp	(hl)

;------------------------------------------------------------------------------
; Exec-Code f. User-Vektoren
;------------------------------------------------------------------------------

DOUVEC:		inc	de
		ex	de, hl
		ld	e, (hl)
		ld	d, 0
		ld	hl, (UPVAR)
		add	hl, de
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		ex	de, hl
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		ex	de, hl
		jp	(hl)

;------------------------------------------------------------------------------
; NOOP
;------------------------------------------------------------------------------

		header	NOOP, "NOOP"

		jp	NEXT

;------------------------------------------------------------------------------
; PAUSE
;------------------------------------------------------------------------------

		header	PAUSE, "PAUSE"

		jp	NEXT

;------------------------------------------------------------------------------
; I
;------------------------------------------------------------------------------

		header	IDO, "I"

		ld	l, (iy+0)
		ld	h, (iy+1)
		ld	e, (iy+2)
		ld	d, (iy+3)
		add	hl, de
		jp	HPUSH

;------------------------------------------------------------------------------
; J
;------------------------------------------------------------------------------

		header	JDO, "J"

		ld	l, (iy+6)
		ld	h, (iy+7)
		ld	e, (iy+8)
		ld	d, (iy+9)
		add	hl, de
		jp	HPUSH

;------------------------------------------------------------------------------
; (LEAVE)
;------------------------------------------------------------------------------

		voc HIDDEN
		header	XLEAVE, "(LEAVE)"

XLEAVE0:	ld	de, 4
		add	iy, de
		ld	c, (iy+0)
		inc	iy
		ld	b, (iy+0)
		inc	iy
		jp	NEXT

;------------------------------------------------------------------------------
; (?LEAVE)
;------------------------------------------------------------------------------

		header	XQLEAVE, "(?LEAVE)"

		pop	hl
		ld	a, h
		or	l
		jp	nz, XLEAVE0
		jp	NEXT

;------------------------------------------------------------------------------
; @
;------------------------------------------------------------------------------

		voc FORTH
		header	AT, "@"

		pop	hl
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		push	de
		jp	NEXT

;------------------------------------------------------------------------------
; !
;------------------------------------------------------------------------------

		header	STORE, "!"

		pop	hl
		pop	de
		ld	(hl), e
		inc	hl
		ld	(hl), d
		jp	NEXT

;------------------------------------------------------------------------------
; C@
;------------------------------------------------------------------------------

		header	CAT, "C@"

		pop	hl
		ld	l, (hl)
		ld	h, 0
		jp	HPUSH

;------------------------------------------------------------------------------
; C!
;------------------------------------------------------------------------------

		header	CSTORE, "C!"

		pop	hl
		pop	de
		ld	(hl), e
		jp	NEXT

;------------------------------------------------------------------------------
; CMOVE
;------------------------------------------------------------------------------

		header	CMOVE, "CMOVE"

		exx
		pop	bc
		pop	de
		pop	hl
		ld	a, b
		or	c
		jr	z, CMOVE1
		ldir
CMOVE1:		exx
		jp	NEXT

;------------------------------------------------------------------------------
; CMOVE>
;------------------------------------------------------------------------------

		header	CMOVETO, "CMOVE>"

		exx
		pop	bc
		pop	de
		pop	hl
		add	hl, bc
		dec	hl
		ex	de, hl
		add	hl, bc
		ex	de, hl
		dec	de
		ld	a, b
		or	c
		jr	z, CMOVETO1
		lddr
CMOVETO1:	exx
		jp	NEXT

;------------------------------------------------------------------------------
; SP@
;------------------------------------------------------------------------------

		header	SPAT, "SP@"

		ld	hl, 0
		add	hl, sp
		jp	HPUSH

;------------------------------------------------------------------------------
; SP!
;------------------------------------------------------------------------------

		header	SPSTORE, "SP!"

		pop	hl
		ld	sp, hl
		jp	NEXT

;------------------------------------------------------------------------------
; RP@
;------------------------------------------------------------------------------

		header	RPAT, "RP@"

		push	iy
		jp	NEXT

;------------------------------------------------------------------------------
; RP!
;------------------------------------------------------------------------------

		header	RPSTORE, "RP!"

		pop	iy
		jp	NEXT

;------------------------------------------------------------------------------
; DROP
;------------------------------------------------------------------------------

		header	DROP, "DROP"

		pop	hl
		jp	NEXT

;------------------------------------------------------------------------------
; DUP
;------------------------------------------------------------------------------

		header	DUPP, "DUP"

		pop	hl
		push	hl
		jp	HPUSH

;------------------------------------------------------------------------------
; SWAP
;------------------------------------------------------------------------------

		header	SWAP, "SWAP"

		pop	hl
		ex	(sp), hl
		jp	HPUSH

;------------------------------------------------------------------------------
; OVER
;------------------------------------------------------------------------------

		header	OVER, "OVER"

		pop	de
		pop	hl
		push	hl
		jp	DPUSH

;------------------------------------------------------------------------------
; TUCK
;------------------------------------------------------------------------------

		header	TUCK, "TUCK"

		pop	hl
		pop	de
		push	hl
		jp	DPUSH

;------------------------------------------------------------------------------
; NIP
;------------------------------------------------------------------------------

		header	NIP, "NIP"

		pop	hl
		pop	de
		jp	HPUSH

;------------------------------------------------------------------------------
; ROT
;------------------------------------------------------------------------------

		header	ROT, "ROT"

		pop	de
		pop	hl
		ex	(sp), hl
		jp	DPUSH

;------------------------------------------------------------------------------
; -ROT
;------------------------------------------------------------------------------

		header	MROT, "-ROT"

		pop	hl
		pop	de
		ex	(sp), hl
		push	hl
		push	de
		jp	NEXT

;------------------------------------------------------------------------------
; ?DUP
;------------------------------------------------------------------------------

		header	QDUPP, "?DUP"

		pop	hl
		ld	a, h
		or	l
		jr	z, QDUPP1
		push	hl
QDUPP1:		jp	HPUSH

;------------------------------------------------------------------------------
; >R
;------------------------------------------------------------------------------

		header	TOR, ">R"

		pop	de
		dec	iy
		dec	iy
		ld	(iy+0),	e
		ld	(iy+1),	d
		jp	NEXT

;------------------------------------------------------------------------------
; R>
;------------------------------------------------------------------------------

		header	FROMR, "R>"

		ld	l, (iy+0)
		inc	iy
		ld	h, (iy+0)
		inc	iy
		jp	HPUSH

;------------------------------------------------------------------------------
; R@
;------------------------------------------------------------------------------

		header	RAT, "R@"

		ld	l, (iy+0)
		ld	h, (iy+1)
		jp	HPUSH

;------------------------------------------------------------------------------
; PICK
;------------------------------------------------------------------------------

		header	PICK, "PICK"

		pop	hl
		add	hl, hl
		add	hl, sp
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		push	de
		jp	NEXT

;------------------------------------------------------------------------------
; ROLL
;------------------------------------------------------------------------------

		header	ROLL, "ROLL"

		exx
		pop	hl
		inc	hl
		add	hl, hl
		ld	b, h
		ld	c, l
		ld	hl, 0
		add	hl, sp
		add	hl, bc
		dec	hl
		ld	d, (hl)
		dec	hl
		ld	e, (hl)
		push	de
		ld	d, h
		ld	e, l
		dec	hl
		inc	de
		lddr
		inc	sp
		inc	sp
		exx
		jp	NEXT

;------------------------------------------------------------------------------
; AND
;------------------------------------------------------------------------------

		header	ANDD, "AND"

		pop	de
		pop	hl
		ld	a, e
		and	l
		ld	l, a
		ld	a, d
		and	h
		ld	h, a
		jp	HPUSH

;------------------------------------------------------------------------------
; OR
;------------------------------------------------------------------------------

		header	ORR, "OR"

		pop	de
		pop	hl
		ld	a, e
		or	l
		ld	l, a
		ld	a, d
		or	h
		ld	h, a
		jp	HPUSH

;------------------------------------------------------------------------------
; XOR
;------------------------------------------------------------------------------

		header	XORR, "XOR"

		pop	de
		pop	hl
		ld	a, e
		xor	l
		ld	l, a
		ld	a, d
		xor	h
		ld	h, a
		jp	HPUSH

;------------------------------------------------------------------------------
; NOT
;------------------------------------------------------------------------------

		header	NOTT, "NOT"

		pop	hl
		ld	a, l
		cpl
		ld	l, a
		ld	a, h
		cpl
		ld	h, a
		jp	HPUSH

;------------------------------------------------------------------------------
; FALSE
; 0 CONSTANT FALSE
;------------------------------------------------------------------------------

		header	FALSEE, "FALSE", DOCON

		dw 0

;------------------------------------------------------------------------------
; TRUE
; -1 CONSTANT TRUE
;------------------------------------------------------------------------------

		header	TRUEE, "TRUE", DOCON

		dw 0FFFFh

;------------------------------------------------------------------------------
; CSET
;------------------------------------------------------------------------------

		header	CSET, "CSET"

		pop	hl
		pop	de
		ld	a, (hl)
		or	e
		ld	(hl), a
		jp	NEXT

;------------------------------------------------------------------------------
; CRESET
;------------------------------------------------------------------------------

		header	CRESET, "CRESET"

		pop	hl
		pop	de
		ld	a, e
		cpl
		and	(hl)
		ld	(hl), a
		jp	NEXT

;------------------------------------------------------------------------------
; CTOGGLE
;------------------------------------------------------------------------------

		header	CTOGGLE, "CTOGGLE"

		pop	hl
		pop	de
		ld	a, (hl)
		xor	e
		ld	(hl), a
		jp	NEXT

;------------------------------------------------------------------------------
; OFF
;------------------------------------------------------------------------------

		header	OFF, "OFF"

		ld	de, 0
OFF1:		pop	hl
		ld	(hl), e
		inc	hl
		ld	(hl), d
		jp	NEXT

;------------------------------------------------------------------------------
; ON
;------------------------------------------------------------------------------

		header	ON, "ON"

		ld	de, 0FFFFh
		jp	OFF1

;------------------------------------------------------------------------------
; +
;------------------------------------------------------------------------------

		header	PLUS, "+"

		pop	hl
		pop	de
		add	hl, de
		jp	HPUSH

;------------------------------------------------------------------------------
; -
;------------------------------------------------------------------------------

		header	MINUS, "-"

		pop	de
		pop	hl
		or	a
		sbc	hl, de
		jp	HPUSH

;------------------------------------------------------------------------------
; NEGATE
;------------------------------------------------------------------------------

		header	NEGATE, "NEGATE"

		pop	de
NEGATE1:	ld	hl, 0
		or	a
		sbc	hl, de
		jp	HPUSH

;------------------------------------------------------------------------------
; ABS
;------------------------------------------------------------------------------

		header	ABS, "ABS"

		pop	de
		ld	a, d
		or	a
		jp	m, NEGATE1
		push	de
		jp	NEXT

;------------------------------------------------------------------------------
; +!
;------------------------------------------------------------------------------

		header	PLUSSTORE, "+!"

		pop	hl
		pop	de
		ld	a, (hl)
		add	a, e
		ld	(hl), a
		inc	hl
		ld	a, (hl)
		adc	a, d
		ld	(hl), a
		jp	NEXT

;------------------------------------------------------------------------------
; 0
; 0 CONSTANT 0
;------------------------------------------------------------------------------

		header	ZERO, "0", DOCON

		dw 0

;------------------------------------------------------------------------------
; 1
; 1 CONSTANT 1
;------------------------------------------------------------------------------

		header	ONE, "1", DOCON

		dw 1

;------------------------------------------------------------------------------
; 2
; 2 CONSTANT 2
;------------------------------------------------------------------------------

		header	TWO, "2", DOCON

		dw 2

;------------------------------------------------------------------------------
; 3
; 3 CONSTANT 3
;------------------------------------------------------------------------------

		header	THREE, "3", DOCON

		dw 3

;------------------------------------------------------------------------------
; 2*
;------------------------------------------------------------------------------

		header	TTIMES, "2*"

		pop	hl
		add	hl, hl
		jp	HPUSH

;------------------------------------------------------------------------------
; 2/
;------------------------------------------------------------------------------

		header	TDIVIDE, "2/"

		pop	hl
		sra	h
		rr	l
		jp	HPUSH

;------------------------------------------------------------------------------
; U2/
;------------------------------------------------------------------------------

		header	UTDIVIDE, "U2/"

		pop	hl
		srl	h
		rr	l
		jp	HPUSH

;------------------------------------------------------------------------------
; 1+
;------------------------------------------------------------------------------

		header	ONEP, "1+"

		pop	hl
		inc	hl
		jp	HPUSH

;------------------------------------------------------------------------------
; 2+
;------------------------------------------------------------------------------

		header	TWOP, "2+"

		pop	hl
		inc	hl
		inc	hl
		jp	HPUSH

;------------------------------------------------------------------------------
; 1-
;------------------------------------------------------------------------------

		header	ONEM, "1-"

		pop	hl
		dec	hl
		jp	HPUSH

;------------------------------------------------------------------------------
; 2-
;------------------------------------------------------------------------------

		header	TWOM, "2-"

		pop	hl
		dec	hl
		dec	hl
		jp	HPUSH

;------------------------------------------------------------------------------
; UM*
;------------------------------------------------------------------------------

		header	UMSTAR, "UM*"

		pop	de
		pop	hl
		push	bc
		ld	a, h
		ld	c, l
		ld	hl, 0
		or	a
		ld	b, 17
UMSTAR2:	rr	h
		rr	l
		rra
		rr	c
		jr	nc, UMSTAR1
		add	hl, de
UMSTAR1:	djnz	UMSTAR2
		ld	d, a
		ld	e, c
		pop	bc
		jp	DPUSH

;------------------------------------------------------------------------------
; UM/MOD
;------------------------------------------------------------------------------

		header	UMMOD, "UM/MOD"

		exx
		pop	bc
		pop	hl
		pop	de
		ld	a, l
		sub	c
		ld	a, h
		sbc	a, b
		jr	c, UMMOD1
		ld	hl, 0FFFFh
		ld	d, h
		ld	e, l
		jr	UMMOD5
UMMOD1:		ld	a, 10h
UMMOD2:		ex	de, hl
		add	hl, hl
		ex	de, hl
		adc	hl, hl
		jr	nc, UMMOD3
		inc	de
		or	a
UMMOD3:		sbc	hl, bc
		jr	nc, UMMOD4
		add	hl, bc
		dec	de
UMMOD4:		inc	de
		dec	a
		jr	nz, UMMOD2
UMMOD5:		push	hl
		push	de
		exx
		jp	NEXT

;------------------------------------------------------------------------------
; 0=
;------------------------------------------------------------------------------

		header	ZEQU, "0="

		pop	hl
ZEQU1:		ld	a, l
		or	h
		ld	hl, 0
		jr	nz, ZEQU2
		dec	hl
ZEQU2:		jp	HPUSH

;------------------------------------------------------------------------------
; 0<
;------------------------------------------------------------------------------

		header	ZLESS, "0<"

		pop	hl
ZLESS1:		add	hl, hl
ZLESS2:		ld	hl, 0
		jr	nc, ZLESS3
		dec	hl
ZLESS3:		jp	HPUSH

;------------------------------------------------------------------------------
; 0>
;------------------------------------------------------------------------------

		header	ZGREAT, "0>"

		pop	de
		ld	hl, 0
		ld	a, d
		rlca
		jr	c, ZGREAT1
		or	e
		jr	z, ZGREAT1
		dec	hl
ZGREAT1:	jp	HPUSH

;------------------------------------------------------------------------------
; =
;------------------------------------------------------------------------------

		header	EQUAL, "="

		pop	de
		pop	hl
		xor	a
		sbc	hl, de
		jp	ZEQU1

;------------------------------------------------------------------------------
; U<
;------------------------------------------------------------------------------

		header	ULESS, "U<"

		or	a
		pop	de
		pop	hl
		sbc	hl, de
		jp	ZLESS2

;------------------------------------------------------------------------------
; <
;------------------------------------------------------------------------------

		header	LESS, "<"

		pop	de
		pop	hl
LESS1:		ld	a, d
		xor	h
		jp	m, ZLESS1
		or	a
		sbc	hl, de
		jp	ZLESS1

;------------------------------------------------------------------------------
; >
;------------------------------------------------------------------------------

		header	GREAT, ">"

		pop	hl
		pop	de
		jp	LESS1

;------------------------------------------------------------------------------
; ?NEGATE
; : ?NEGATE   0< IF NEGATE THEN ;
;------------------------------------------------------------------------------

		header	QNEGATE, "?NEGATE", DOCOL

		dw ZLESS
		dw QBRANCH
		dw QNEGATE1
		dw NEGATE
QNEGATE1:	dw UNNEST

;------------------------------------------------------------------------------
; MIN
; : MIN   ( n1 n2 -- n3 )   OVER OVER > IF SWAP THEN DROP ;
;------------------------------------------------------------------------------

		header	MIN, "MIN", DOCOL

		dw OVER
		dw OVER
		dw GREAT
		dw QBRANCH
		dw MIN1
		dw SWAP
MIN1:		dw DROP
		dw UNNEST

;------------------------------------------------------------------------------
; MAX
; : MAX    ( n1 n2 -- n3 )   OVER OVER < IF SWAP THEN DROP ;
;------------------------------------------------------------------------------

		header	MAX, "MAX", DOCOL

		dw OVER
		dw OVER
		dw LESS
		dw QBRANCH
		dw MAX1
		dw SWAP
MAX1:		dw DROP
		dw UNNEST

;------------------------------------------------------------------------------
; BETWEEN
; : BETWEEN   >R OVER > SWAP R> > OR NOT ;
;------------------------------------------------------------------------------

		header	BETWEEN, "BETWEEN", DOCOL

		dw TOR
		dw OVER
		dw GREAT
		dw SWAP
		dw FROMR
		dw GREAT
		dw ORR
		dw NOTT
		dw UNNEST

;------------------------------------------------------------------------------
; 2@
;------------------------------------------------------------------------------

		header	TAT, "2@"

		exx
		pop	hl
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		inc	hl
		ld	c, (hl)
		inc	hl
		ld	b, (hl)
		push	bc
		push	de
		exx
		jp	NEXT

;------------------------------------------------------------------------------
; 2!
;------------------------------------------------------------------------------

		header	TSTOR, "2!"

		pop	hl
		pop	de
		ld	(hl), e
		inc	hl
		ld	(hl), d
		inc	hl
		pop	de
		ld	(hl), e
		inc	hl
		ld	(hl), d
		jp	NEXT

;------------------------------------------------------------------------------
; 2DROP
;------------------------------------------------------------------------------

		header	TDROP, "2DROP"

		pop	hl
		pop	hl
		jp	NEXT

;------------------------------------------------------------------------------
; 2DUP
;------------------------------------------------------------------------------

		header	TDUPP, "2DUP"

		pop	hl
		pop	de
		push	de
		push	hl
		jp	DPUSH

;------------------------------------------------------------------------------
; 2SWAP
;------------------------------------------------------------------------------

		header	TSWAP, "2SWAP"

		exx
		pop	de
		pop	hl
		pop	bc
		ex	(sp), hl
		push	de
		push	hl
		push	bc
		exx
		jp	NEXT

;------------------------------------------------------------------------------
; 2OVER
;------------------------------------------------------------------------------

		header	TOVER, "2OVER"

		exx
		pop	af
		pop	bc
		pop	de
		pop	hl
		push	hl
		push	de
		push	bc
		push	af
		push	hl
		push	de
		exx
		jp	NEXT

;------------------------------------------------------------------------------
; 2ROT
; : 2ROT   5 ROLL 5 ROLL ;
;------------------------------------------------------------------------------

		header	TROT, "2ROT", DOCOL

		dw XLIT
		dw 5
		dw ROLL
		dw XLIT
		dw 5
		dw ROLL
		dw UNNEST

;------------------------------------------------------------------------------
; D+
;------------------------------------------------------------------------------

		header	DPLUS, "D+"

		exx
		pop	bc
		pop	de
		pop	hl
		ex	(sp), hl
		add	hl, de
		ex	de, hl
		pop	hl
		adc	hl, bc
		push	de
		push	hl
		exx
		jp	NEXT

;------------------------------------------------------------------------------
; DNEGATE
;------------------------------------------------------------------------------

		header	DNEGATE, "DNEGATE"

DENEGATE0:	exx
		pop	de
		pop	bc
		ld	hl, 0
		or	a
		sbc	hl, bc
		push	hl
		ld	hl, 0
		sbc	hl, de
		push	hl
		exx
		jp	NEXT

;------------------------------------------------------------------------------
; S>D
;------------------------------------------------------------------------------

		header	STOD, "S>D"

		pop	de
		ld	hl, 0
		ld	a, d
		and	80h ; ''
		jr	z, STOD1
		dec	hl
STOD1:		jp	DPUSH

;------------------------------------------------------------------------------
; DABS
;------------------------------------------------------------------------------

		header	DABS, "DABS"

		pop	de
		push	de
		ld	a, d
		or	a
		jp	m, DENEGATE0
		jp	NEXT

;------------------------------------------------------------------------------
; D2/
;------------------------------------------------------------------------------

		header	DTSLASH, "D2/"

		pop	hl
		pop	de
		sra	h
		rr	l
		rr	d
		rr	e
		jp	DPUSH

;------------------------------------------------------------------------------
; D-
; : D-   DNEGATE D+ ;
;------------------------------------------------------------------------------

		header	DMINUS, "D-", DOCOL

		dw DNEGATE
		dw DPLUS
		dw UNNEST

;------------------------------------------------------------------------------
; ?DNEGATE
; : ?DNEGATE   0< IF DNEGATE THEN ;
;------------------------------------------------------------------------------

		header	QDNEGATE, "?DNEGATE", DOCOL

		dw ZLESS
		dw QBRANCH
		dw off_BB8
		dw DNEGATE
off_BB8:	dw UNNEST

;------------------------------------------------------------------------------
; D0=
; : D0=   OR 0= ;
;------------------------------------------------------------------------------

		header	DZEQU, "D0=", DOCOL

		dw ORR
		dw ZEQU
		dw UNNEST

;------------------------------------------------------------------------------
; D=
; : D=   D- D0= ;
;------------------------------------------------------------------------------

		header	DEQUAL, "D=", DOCOL

		dw DMINUS
		dw DZEQU
		dw UNNEST

;------------------------------------------------------------------------------
; DU<
; : DU<   ROT SWAP 2DUP U< IF 2DROP 2DROP TRUE 
;    ELSE = IF U< ELSE 2DROP FALSE THEN THEN ;
;------------------------------------------------------------------------------

		header	DULESS, "DU<", DOCOL

		dw ROT
		dw SWAP
		dw TDUPP
		dw ULESS
		dw QBRANCH
		dw off_BF3
		dw TDROP
		dw TDROP
		dw TRUEE
		dw BRANCH
		dw off_C03
off_BF3:	dw EQUAL
		dw QBRANCH
		dw off_BFF
		dw ULESS
		dw BRANCH
		dw off_C03
off_BFF:	dw TDROP
		dw FALSEE
off_C03:	dw UNNEST

;------------------------------------------------------------------------------
; D<
; : D<   2 PICK OVER = IF DU< ELSE NIP ROT DROP < THEN ;
;------------------------------------------------------------------------------

		header	DLESS, "D<", DOCOL

		dw TWO
		dw PICK
		dw OVER
		dw EQUAL
		dw QBRANCH
		dw off_C1E
		dw DULESS
		dw BRANCH
		dw off_C26
off_C1E:	dw NIP
		dw ROT
		dw DROP
		dw LESS
off_C26:	dw UNNEST

;------------------------------------------------------------------------------
; D>
; : D>   2SWAP D< ;
;------------------------------------------------------------------------------

		header	DGREAT, "D>", DOCOL

		dw TSWAP
		dw DLESS
		dw UNNEST

;------------------------------------------------------------------------------
; DMIN
; : DMIN   2OVER 2OVER D> IF 2SWAP THEN 2DROP ;
;------------------------------------------------------------------------------

		header	DMIN, "DMIN", DOCOL

		dw TOVER
		dw TOVER
		dw DGREAT
		dw QBRANCH
		dw off_C4A
		dw TSWAP
off_C4A:	dw TDROP
		dw UNNEST

;------------------------------------------------------------------------------
; DMAX
; : DMAX   2OVER 2OVER D< IF 2SWAP THEN 2DROP ;
;------------------------------------------------------------------------------

		header	DMAX, "DMAX", DOCOL

		dw TOVER
		dw TOVER
		dw DLESS
		dw QBRANCH
		dw off_C63
		dw TSWAP
off_C63:	dw TDROP
		dw UNNEST

;------------------------------------------------------------------------------
; *D
; : *D   2DUP XOR >R ABS SWAP ABS UM* R> ?DNEGATE ;
;------------------------------------------------------------------------------

		header	STARD, "*D", DOCOL

		dw TDUPP
		dw XORR
		dw TOR
		dw ABS
		dw SWAP
		dw ABS
		dw UMSTAR
		dw FROMR
		dw QDNEGATE
		dw UNNEST

;------------------------------------------------------------------------------
; M/MOD
; : M/MOD    DUP >R 2DUP XOR >R >R DABS R@ ABS UM/MOD SWAP R> ?NEGATE SWAP R> 
;    0< IF NEGATE OVER IF 1- R@ ROT - SWAP THEN THEN R> DROP ;
;------------------------------------------------------------------------------

		header	MMOD, "M/MOD", DOCOL

		dw DUPP
		dw TOR
		dw TDUPP
		dw XORR
		dw TOR
		dw TOR
		dw DABS
		dw RAT
		dw ABS
		dw UMMOD
		dw SWAP
		dw FROMR
		dw QNEGATE
		dw SWAP
		dw FROMR
		dw ZLESS
		dw QBRANCH
		dw off_CC2
		dw NEGATE
		dw OVER
		dw QBRANCH
		dw off_CC2
		dw ONEM
		dw RAT
		dw ROT
		dw MINUS
		dw SWAP
off_CC2:	dw FROMR
		dw DROP
		dw UNNEST

;------------------------------------------------------------------------------
; MU/MOD
; : MU/MOD   >R 0 R@ UM/MOD R> SWAP >R UM/MOD R> ;
;------------------------------------------------------------------------------

		header	MUMOD, "MU/MOD", DOCOL

		dw TOR
		dw ZERO
		dw RAT
		dw UMMOD
		dw FROMR
		dw SWAP
		dw TOR
		dw UMMOD
		dw FROMR
		dw UNNEST

;------------------------------------------------------------------------------
; *
; : *   UM* DROP ;
;------------------------------------------------------------------------------

		header	STAR, "*", DOCOL

		dw UMSTAR
		dw DROP
		dw UNNEST

;------------------------------------------------------------------------------
; /MOD
; : /MOD   >R S>D R> M/MOD ;
;------------------------------------------------------------------------------

		header	SMOD, "/MOD", DOCOL

		dw TOR
		dw STOD
		dw FROMR
		dw MMOD
		dw UNNEST

;------------------------------------------------------------------------------
; /
; : /   /MOD NIP ;
;------------------------------------------------------------------------------

		header	SLASH, "/", DOCOL

		dw SMOD
		dw NIP
		dw UNNEST

;------------------------------------------------------------------------------
; MOD
; : MOD   /MOD DROP ;
;------------------------------------------------------------------------------

		header	MOD, "MOD", DOCOL

		dw SMOD
		dw DROP
		dw UNNEST

;------------------------------------------------------------------------------
; */MOD
; : */MOD   >R *D R> M/MOD ;
;------------------------------------------------------------------------------

		header	SSMOD, "*/MOD", DOCOL

		dw TOR
		dw STARD
		dw FROMR
		dw MMOD
		dw UNNEST

;------------------------------------------------------------------------------
; */
; : */   */MOD NIP ;
;------------------------------------------------------------------------------

		header	SMODX, "*/", DOCOL

		dw SSMOD
		dw NIP
		dw UNNEST

;------------------------------------------------------------------------------
; TOS
; USER VARIABLE TOS
;------------------------------------------------------------------------------

		header	TOS, "TOS", DOUSE

		dw 0

;------------------------------------------------------------------------------
; ENTRY
; USER VARIABLE ENTRY
;------------------------------------------------------------------------------

		header	ENTRY, "ENTRY", DOUSE

		dw 2

;------------------------------------------------------------------------------
; LINK
; USER VARIABLE LINK
;------------------------------------------------------------------------------

		header	LINK, "LINK", DOUSE

		dw 4

;------------------------------------------------------------------------------
; SP0
; USER VARIABLE SP0
;------------------------------------------------------------------------------

		header	SPZ, "SP0", DOUSE

		dw 6

;------------------------------------------------------------------------------
; RP0
; USER VARIABLE RP0
;------------------------------------------------------------------------------

		header	RPZ, "RP0", DOUSE

		dw 8

;------------------------------------------------------------------------------
; DP
; USER VARIABLE DP
;------------------------------------------------------------------------------

		header	DP, "DP", DOUSE

		dw 0Ah

;------------------------------------------------------------------------------
; #OUT
; USER VARIABLE #OUT
;------------------------------------------------------------------------------

		header	NOUT, "#OUT", DOUSE

		dw 0Ch

;------------------------------------------------------------------------------
; #LINE
; USER VARIABLE #LINE
;------------------------------------------------------------------------------

		header	NLINE, "#LINE", DOUSE

		dw 0Eh

;------------------------------------------------------------------------------
; OFFSET
; USER VARIABLE OFFSET
;------------------------------------------------------------------------------

		header	OFFSET, "OFFSET", DOUSE

		dw 10h

;------------------------------------------------------------------------------
; BASE
; USER VARIABLE BASE
;------------------------------------------------------------------------------

		header	BASE, "BASE", DOUSE

		dw 12h

;------------------------------------------------------------------------------
; HLD
; USER VARIABLE HLD
;------------------------------------------------------------------------------

		header	HLD, "HLD", DOUSE

		dw 14h

;------------------------------------------------------------------------------
; PRINTING
; USER VARIABLE PRINTING
;------------------------------------------------------------------------------

		header	PRINTING, "PRINTING", DOUSE

		dw 16h

;------------------------------------------------------------------------------
; EMIT
; USER DEFER EMIT
; ' (EMIT) IS EMIT
;------------------------------------------------------------------------------

		header	EMIT, "EMIT", DOUVEC

		dw 18h

;------------------------------------------------------------------------------
; CR
; USER DEFER CR
; ' (CR) IS CR
;------------------------------------------------------------------------------

		header	CR, "CR", DOUVEC

		dw 1Ah

;------------------------------------------------------------------------------
; FENCE
; VARIABLE FENCE
;------------------------------------------------------------------------------

		header	FENCE, "FENCE", DOVAR

		dw eof

;------------------------------------------------------------------------------
; SCR
; VARIABLE SCR
;------------------------------------------------------------------------------

		header	SCR, "SCR", DOVAR

		dw 1

;------------------------------------------------------------------------------
; PRIOR
;------------------------------------------------------------------------------

		header	PRIOR, "PRIOR", DOVAR

		dw VFORTH1

;------------------------------------------------------------------------------
; STATE
;------------------------------------------------------------------------------

		header	STATE, "STATE", DOVAR

		dw 0

;------------------------------------------------------------------------------
; DPL
;------------------------------------------------------------------------------

		header	DPL, "DPL", DOVAR

		dw 0FFFFh

;------------------------------------------------------------------------------
; R#
;------------------------------------------------------------------------------

		header	RN, "R#", DOVAR

		dw 0D7h

;------------------------------------------------------------------------------
; LAST
;------------------------------------------------------------------------------

		header	LAST, "LAST", DOVAR

		dw eof
	
;------------------------------------------------------------------------------
; CSP
;------------------------------------------------------------------------------

		header	CSP, "CSP", DOVAR

					; init_top - B/BUF - 200 = RP0-200
	if sysver == "Z9001"
		dw 5E00h - 200
	elseif sysver == "BIC"
		dw 7C00h - 200
	else
		dw 3200h - 200
	endif

;------------------------------------------------------------------------------
; CURRENT
;------------------------------------------------------------------------------

		header	CURRENT, "CURRENT", DOVAR

		dw VFORTH1

;------------------------------------------------------------------------------
; #VOCS
; 8 CONSTANT #VOCS
;------------------------------------------------------------------------------

		header	VOCS, "#VOCS", DOCON

		dw 8

;------------------------------------------------------------------------------
; CONTEXT
; VARIABLE  CONTEXT
; HERE #VOCS 2* DUP ALLOT ERASE
;------------------------------------------------------------------------------

		header	CONTEXT, "CONTEXT", DOVAR

		dw VFORTH1
		dw VFORTH1
		dw 0
		dw 0
		dw 0
		dw 0
		dw 0
		dw off_26E9
		dw 0

;------------------------------------------------------------------------------
; 'TIB
; VARIABLE  'TIB
;------------------------------------------------------------------------------

		header	TTIB, "'TIB", DOVAR

TTIBV:					; wird bei cld1 initialisiert
	if sysver == "Z9001"
		dw 5D38h
	elseif sysver == "BIC"
		dw 9B38h
	else

		dw 3138h
	endif

;------------------------------------------------------------------------------
; WIDTH
; VARIABLE  WIDTH
;------------------------------------------------------------------------------

		header	WIDTH, "WIDTH", DOVAR

		dw 1Fh

;------------------------------------------------------------------------------
; WARNING
;------------------------------------------------------------------------------

		header	WARNING, "WARNING", DOVAR

		dw 0FFFFh

;------------------------------------------------------------------------------
; VOC-LINK
; VARIABLE  VOC-LINK
;------------------------------------------------------------------------------

		header	VOCLINK, "VOC-LINK", DOVAR

		if sysver == "BIC"
			dw VDOSL
		else
			dw VROOTL
		endif

;------------------------------------------------------------------------------
; BLK
;------------------------------------------------------------------------------

		header	BLK, "BLK", DOVAR

		dw 0

;------------------------------------------------------------------------------
; >IN
;------------------------------------------------------------------------------

		header	TOIN, ">IN", DOVAR

		dw 4

;------------------------------------------------------------------------------
; SPAN
;------------------------------------------------------------------------------

		header	SPAN, "SPAN", DOVAR

		dw 3

;------------------------------------------------------------------------------
; #TIB
;------------------------------------------------------------------------------

		header	NTIB, "#TIB", DOVAR

		dw 3

;------------------------------------------------------------------------------
; BL
; 32 CONSTANT BL
;------------------------------------------------------------------------------

		header	BL, "BL", DOCON

		dw 20h

;------------------------------------------------------------------------------
; BS
; 8 CONSTANT BS
;------------------------------------------------------------------------------

		header	BS, "BS", DOCON

		dw 8

;------------------------------------------------------------------------------
; BELL
; 7 CONSTANT BELL
;------------------------------------------------------------------------------

		header	BELL, "BELL", DOCON

		dw 7

;------------------------------------------------------------------------------
; HERE
; : HERE   DP @ ;
;------------------------------------------------------------------------------

		header	HERE, "HERE", DOCOL

		dw DP
		dw AT
		dw UNNEST

;------------------------------------------------------------------------------
; PAD
; HEX : PAD   HERE 50 + ;
;------------------------------------------------------------------------------

		header	PAD, "PAD", DOCOL

		dw HERE
		dw XLIT
		dw 50h
		dw PLUS
		dw UNNEST

;------------------------------------------------------------------------------
; FILL
;------------------------------------------------------------------------------

		header	FILL, "FILL"

		exx
		pop	de
		pop	bc
		pop	hl
		ld	a, b
		or	c
		jr	z, loc_F21
		ld	(hl), e
		dec	bc
		ld	a, b
		or	c
		jr	z, loc_F21
		ld	d, h
		ld	e, l
		inc	de
		ldir
loc_F21:	exx
		jp	NEXT

;------------------------------------------------------------------------------
; ERASE
; : ERASE   0 FILL ;
;------------------------------------------------------------------------------

		header	ERASE, "ERASE", DOCOL

		dw ZERO
		dw FILL
		dw UNNEST

;------------------------------------------------------------------------------
; BLANK
; : BLANK   BL FILL ;
;------------------------------------------------------------------------------

		header	BLANK, "BLANK", DOCOL

		dw BL
		dw FILL
		dw UNNEST

;------------------------------------------------------------------------------
; MOVE
; : MOVE   -ROT 2DUP U< IF ROT CMOVE> ELSE ROT CMOVE THEN ;
;------------------------------------------------------------------------------

		header	MOVE, "MOVE", DOCOL

		dw MROT
		dw TDUPP
		dw ULESS
		dw QBRANCH
		dw off_F60
		dw ROT
		dw CMOVETO
		dw BRANCH
		dw off_F64
off_F60:	dw ROT
		dw CMOVE
off_F64:	dw UNNEST

;------------------------------------------------------------------------------
; COUNT
;------------------------------------------------------------------------------

		header	COUNT, "COUNT"

		pop	hl
		ld	e, (hl)
		ld	d, 0
		inc	hl
		ex	de, hl
		jp	DPUSH

;------------------------------------------------------------------------------
; TYPE
; : TYPE   0 ?DO COUNT EMIT LOOP DROP ;
;------------------------------------------------------------------------------

		header	TYPE, "TYPE", DOCOL

		dw ZERO
		dw XQDO
		dw off_F90
off_F88:	dw COUNT
		dw EMIT
		dw XLOOP
		dw off_F88
off_F90:	dw DROP
		dw UNNEST

;------------------------------------------------------------------------------
; SPACE
; : SPACE   BL EMIT ;
;------------------------------------------------------------------------------

		header	SPACE, "SPACE", DOCOL

		dw BL
		dw EMIT
		dw UNNEST

;------------------------------------------------------------------------------
; SPACES
; : SPACES   0 MAX 0 ?DO SPACE LOOP ;
;------------------------------------------------------------------------------

		header	SPACES, "SPACES", DOCOL

		dw ZERO
		dw MAX
		dw ZERO
		dw XQDO
		dw off_FBF
off_FB9:	dw SPACE
		dw XLOOP
		dw off_FB9
off_FBF:	dw UNNEST

;------------------------------------------------------------------------------
; -TRAILING
; : -TRAILING   DUP 0 DO 2DUP + 1- C@ BL = NOT ?LEAVE 1- LOOP ;
;------------------------------------------------------------------------------

		header	MTRAILING, "-TRAILING", DOCOL

		dw DUPP
		dw ZERO
		dw XDO
		dw off_FED
off_FD7:	dw TDUPP
		dw PLUS
		dw ONEM
		dw CAT
		dw BL
		dw EQUAL
		dw NOTT
		dw XQLEAVE
		dw ONEM
		dw XLOOP
		dw off_FD7
off_FED:	dw UNNEST

;------------------------------------------------------------------------------
; COMPARE
;------------------------------------------------------------------------------

		header	COMPARE, "COMPARE"

		exx
		pop	bc
		pop	hl
		pop	de
loc_FFF:	ld	a, b
		or	c
		jr	z, loc_1016
		ld	a, (de)
		cp	(hl)
		jr	nz, loc_100C
		dec	bc
		inc	hl
		inc	de
		jr	loc_FFF
loc_100C:	jr	nc, loc_1013
		ld	bc, 0FFFFh
		jr	loc_1016
loc_1013:	ld	bc, 1
loc_1016:	push	bc
		exx
		jp	NEXT

;------------------------------------------------------------------------------
; KEY
; DEFER KEY
; ' (KEY) IS KEY
;------------------------------------------------------------------------------

		header	KEY, "KEY", DOVEC

		dw XKEY

;------------------------------------------------------------------------------
; KEY?
; DEFER KEY?
; ' (KEY?) IS KEY?
;------------------------------------------------------------------------------

		header	KEYQ, "KEY?", DOVEC

		dw XKEYQ

;------------------------------------------------------------------------------
; I/O
;------------------------------------------------------------------------------

		header	VIO, "I/O", DOVOC

VIO1:		dw lstlnk_8
		dw lstlnk_9
		dw lstlnk_A
		dw lstlnk_B
VIOL:		dw VHIDDENL

;------------------------------------------------------------------------------
; OS
;------------------------------------------------------------------------------

		VOC IO
		header	OS, "OS"

		pop	de
		ld	hl, ostab	; Liste	der Systemaufrufe
		add	hl, de
		jp	(hl)

;------------------------------------------------------------------------------
; (KEY?)
; : (KEY?)   6 OS 0= NOT ;
;------------------------------------------------------------------------------

		header	XKEYQ, "(KEY?)", DOCOL

		dw XLIT
		dw 6			; Offset Systemaufruf CSTS
		dw OS
		dw ZEQU
		dw NOTT
		dw UNNEST

;------------------------------------------------------------------------------
; (KEY)
; ( Z1013) : (KEY)   BEGIN PAUSE 6 OS ?DUP UNTIL ;
; ( Z9001) : (KEY)   BEGIN PAUSE 0 OS ?DUP UNTIL ;
;------------------------------------------------------------------------------

		header	XKEY, "(KEY)", DOCOL

		if sysver == "Z1013"
off_1070:	dw PAUSE
		dw SIX
		dw OS
		dw QDUPP
		dw QBRANCH
		dw off_1070
		dw UNNEST
		elseif sysver = "Z9001"
off_1070:	dw PAUSE
		dw ZERO
		dw OS
		dw QDUPP
		dw QBRANCH
		dw off_1070
		dw UNNEST
		elseif sysver = "BIC"
off_E50:        dw PAUSE
                dw XKEYQ
                dw QBRANCH
                dw off_E50
                dw ZERO
                dw OS
                dw UNNEST
		endif

;------------------------------------------------------------------------------
; (CONSOLE)
; : (CONSOLE)   PAUSE 3 OS 1 #OUT +! ;
;------------------------------------------------------------------------------

		header	XCONSOL, "(CONSOLE)", DOCOL

		dw PAUSE
		dw THREE
		dw OS
		dw ONE
		dw NOUT
		dw PLUSSTORE
		dw UNNEST

;------------------------------------------------------------------------------
; (PRINT)
; : (PRINT)   PAUSE 9 OS 1 #OUT +! ;
;------------------------------------------------------------------------------

		header	XPRINT, "(PRINT)", DOCOL

		dw PAUSE
		dw XLIT
		dw 9
		dw OS
		dw ONE
		dw NOUT
		dw PLUSSTORE
		dw UNNEST

;------------------------------------------------------------------------------
; (EMIT)
; : (EMIT)   PRINTING @ IF DUP (PRINT) -1 #OUT +! THEN (CONSOLE) ;
;------------------------------------------------------------------------------

		header	XEMIT, "(EMIT)", DOCOL

		dw PRINTING
		dw AT
		dw QBRANCH
		dw off_10D5
		dw DUPP
		dw XPRINT
		dw XLIT
		dw 0FFFFh
		dw NOUT
		dw PLUSSTORE
off_10D5:	dw XCONSOL
		dw UNNEST

;------------------------------------------------------------------------------
; CRLF
; HEX : CRLF   0D EMIT 0A EMIT #OUT OFF 1 #LINE +! ;
;------------------------------------------------------------------------------

		header	CRLF, "CRLF", DOCOL

		dw XLIT
		dw 0Dh
		dw EMIT
		dw XLIT
		dw 0Ah
		dw EMIT
		dw NOUT
		dw OFF
		dw ONE
		dw NLINE
		dw PLUSSTORE
		dw UNNEST

;------------------------------------------------------------------------------
; EXPECT
; DEFER EXPECT   
; ' (EXPECT) IS EXPECT 
;------------------------------------------------------------------------------

		voc FORTH
		header	EXPECT, "EXPECT", DOVEC

		dw XEXPECT

;------------------------------------------------------------------------------
; DEL-IN
; : DEL-IN   DROP DUP IF 1- BS EMIT SPACE BS ELSE BELL THEN EMIT ;
;------------------------------------------------------------------------------

		voc HIDDEN
		header	DELIN, "DEL-IN", DOCOL

		dw DROP
		dw DUPP
		dw QBRANCH
		dw off_1128
		dw ONEM
		dw BS
		dw EMIT
		dw SPACE
		dw BS
		dw BRANCH
		dw off_112A
off_1128:	dw BELL
off_112A:	dw EMIT
		dw UNNEST

;------------------------------------------------------------------------------
; CR-IN
; : CR-IN   DROP SPAN ! OVER BL EMIT ;
;------------------------------------------------------------------------------

		header	CRIN, "CR-IN", DOCOL

		dw DROP
		dw SPAN
		dw STORE
		dw OVER
		dw BL
		dw EMIT
		dw UNNEST

;------------------------------------------------------------------------------
; CHAR
; : CHAR   >R R@ EMIT 2DUP + R> SWAP C! 1+ ;
;------------------------------------------------------------------------------

		header	CHAR, "CHAR", DOCOL

		dw TOR
		dw RAT
		dw EMIT
		dw TDUPP
		dw PLUS
		dw FROMR
		dw SWAP
		dw CSTORE
		dw ONEP
		dw UNNEST

;------------------------------------------------------------------------------
; (EXPECT)
; : (EXPECT)   DUP SPAN ! SWAP 0 BEGIN 2 PICK OVER -
;    WHILE KEY DUP 0D = IF CR-IN ELSE DUP 7F = OVER BS = OR
;    IF DEL-IN ELSE CHAR THEN THEN REPEAT 2DROP DROP ;
;------------------------------------------------------------------------------

		header	XEXPECT, "(EXPECT)", DOCOL

		dw DUPP
		dw SPAN
		dw STORE
		dw SWAP
		dw ZERO
off_117A:	dw TWO
		dw PICK
		dw OVER
		dw MINUS
		dw QBRANCH
		dw off_11BA
		dw KEY
		dw DUPP
		dw XLIT
		dw 0Dh
		dw EQUAL
		dw QBRANCH
		dw off_119A
		dw CRIN
		dw BRANCH
		dw off_11B6
off_119A:	dw DUPP
		dw XLIT
		dw 7Fh
		dw EQUAL
		dw OVER
		dw BS
		dw EQUAL
		dw ORR
		dw QBRANCH
		dw off_11B4
		dw DELIN
		dw BRANCH
		dw off_11B6
off_11B4:	dw CHAR
off_11B6:	dw BRANCH
		dw off_117A
off_11BA:	dw TDROP
		dw DROP
		dw UNNEST

;------------------------------------------------------------------------------
; TIB
; : TIB   'TIB @ ;
;------------------------------------------------------------------------------

		voc FORTH
		header	TIB, "TIB", DOCOL

		dw TTIB
		dw AT
		dw UNNEST

;------------------------------------------------------------------------------
; QUERY
; HEX : QUERY   TIB 50 EXPECT SPAN @ #TIB ! BLK OFF >IN OFF ;
;------------------------------------------------------------------------------

		header	QUERY, "QUERY", DOCOL

		dw TIB
		dw XLIT
		dw 50h
		dw EXPECT
		dw SPAN
		dw AT
		dw NTIB
		dw STORE
		dw BLK
		dw OFF
		dw TOIN
		dw OFF
		dw UNNEST

;------------------------------------------------------------------------------
; B/BUF
; 200 CONSTANT B/BUF
;------------------------------------------------------------------------------

		header	BBUF, "B/BUF", DOCON

BBUF1:		if sysver == "Z1013"
		dw 200h
		elseif sysver == "Z9001"
		dw 200h
		elseif sysver == "BIC"
		dw 400h
		endif

;------------------------------------------------------------------------------
; FIRST
;------------------------------------------------------------------------------
		
		header	FIRST, "FIRST", DOCON

FIRSTC:						; FIRST := init_top - B/BUF
		if sysver == "Z1013"
		dw 3200h			 
		elseif sysver == "Z9001"
		dw 5E00h
		elseif sysver == "BIC"
		dw 9C00h
		endif

;------------------------------------------------------------------------------
; UPD
;------------------------------------------------------------------------------

		voc HIDDEN
		header	UPD, "UPD", DOVAR

		dw 0

;------------------------------------------------------------------------------
; BLK#
;------------------------------------------------------------------------------

		header	BLKNUM, "BLK#", DOVAR

		dw 0FFFFh

;------------------------------------------------------------------------------
; READ-BLOCK
; DEFER READ-BLOCK
; ' READ IS READ-BLOCK
;------------------------------------------------------------------------------

		voc FORTH
		header	READBLK, "READ-BLOCK", DOVEC

	if sysver == "BIC"
		dw CREAD
	else		
		dw READ
	endif
		
;------------------------------------------------------------------------------
; WRITE-BLOCK
; DEFER WRITE-BLOCK
; ' WRITE IS WRITE-BLOCK
;------------------------------------------------------------------------------

		header	WRITEBLK, "WRITE-BLOCK", DOVEC

	if sysver == "BIC"
		dw CWRITE
	else		
		dw WRITE
	endif

;------------------------------------------------------------------------------
; EMPTY-BUFFERS
; : EMPTY-BUFFERS   FIRST B/BUF ERASE UPD OFF BLK# ON ;
;------------------------------------------------------------------------------

		header	EMPTYBUF, "EMPTY-BUFFERS", DOCOL

		dw FIRST
		dw BBUF
		dw ERASE
		dw UPD
		dw OFF
		dw BLKNUM
		dw ON
		dw UNNEST

;------------------------------------------------------------------------------
; SAVE-BUFFERS
; : SAVE-BUFFERS   UPD @ IF FIRST BLK# @ WRITE-BLOCK UPD OFF THEN ;
;------------------------------------------------------------------------------

		header	SAVEBUF, "SAVE-BUFFERS", DOCOL

		dw UPD
		dw AT
		dw QBRANCH
		dw off_1289
		dw FIRST
		dw BLKNUM
		dw AT
		dw WRITEBLK
		dw UPD
		dw OFF
off_1289:	dw UNNEST

;------------------------------------------------------------------------------
; FLUSH
; : FLUSH   SAVE-BUFFERS EMPTY-BUFFERS ;
;------------------------------------------------------------------------------

		header	FLUSH, "FLUSH", DOCOL

		dw SAVEBUF
		dw EMPTYBUF
		dw UNNEST

;------------------------------------------------------------------------------
; ABSENT?
; : ABSENT?   DUP BLK# @ = NOT ;
;------------------------------------------------------------------------------

		voc HIDDEN
		header	ABSENTQ, "ABSENT?", DOCOL

		dw DUPP
		dw BLKNUM
		dw AT
		dw EQUAL
		dw NOTT
		dw UNNEST

;------------------------------------------------------------------------------
; UPDATE
; : UPDATE UPD ON ;
;------------------------------------------------------------------------------
		
		voc FORTH
		header	UPDATE, "UPDATE", DOCOL

		dw UPD
		dw ON
		dw UNNEST

;------------------------------------------------------------------------------
; BUFFER
; : BUFFER   PAUSE OFFSET @ + ABSENT? IF SAVE-BUFFERS THEN BLK# ! FIRST ;
;------------------------------------------------------------------------------

		header	BUFFER, "BUFFER", DOCOL

		dw PAUSE
		dw OFFSET
		dw AT
		dw PLUS
		dw ABSENTQ
		dw QBRANCH
		dw off_12DF
		dw SAVEBUF
off_12DF:	dw BLKNUM
		dw STORE
		dw FIRST
		dw UNNEST

;------------------------------------------------------------------------------
; BLOCK
; : BLOCK   PAUSE OFFSET @ + ABSENT? 
;    IF SAVE-BUFFERS FIRST OVER READ-BLOCK THEN BLK# ! FIRST ;
;------------------------------------------------------------------------------

		header	BLOCK, "BLOCK", DOCOL

		dw PAUSE
		dw OFFSET
		dw AT
		dw PLUS
		dw ABSENTQ
		dw QBRANCH
		dw BLOCK1
		dw SAVEBUF
		dw FIRST
		dw OVER
		dw READBLK
BLOCK1:		dw BLKNUM
		dw STORE
		dw FIRST
		dw UNNEST

;------------------------------------------------------------------------------
; SOD
;------------------------------------------------------------------------------

		voc IO
		header	SOD, "SOD", DOCON

		dw init_sod

;------------------------------------------------------------------------------
; EOD
;------------------------------------------------------------------------------

		header	EOD, "EOD", DOCON

		dw init_eod

;------------------------------------------------------------------------------
; MAX#
; : MAX#   EOD @ SOD @ - B/BUF / ;
;------------------------------------------------------------------------------

		header	MAXNUM, "MAX#", DOCOL

		dw EOD
		dw AT
		dw SOD
		dw AT
		dw MINUS
		dw BBUF
		dw SLASH
		dw UNNEST

;------------------------------------------------------------------------------
; 'RAM
; : 'RAM   1- MAX# 1- OVER U< ABORT" out of Disk " B/BUF * SOD @ + ;
;------------------------------------------------------------------------------

		header	TRAM, "'RAM", DOCOL

		dw ONEM
		dw MAXNUM
		dw ONEM
		dw OVER
		dw ULESS
		dw XABORT
		db 12,"out of Disk "
		dw BBUF
		dw STAR
		dw SOD
		dw AT
		dw PLUS
		dw UNNEST

;------------------------------------------------------------------------------
; READ
; : READ   'RAM SWAP B/BUF CMOVE ;
;------------------------------------------------------------------------------

		header	READ, "READ", DOCOL

		dw TRAM
		dw SWAP
		dw BBUF
		dw CMOVE
		dw UNNEST

;------------------------------------------------------------------------------
; WRITE
; : WRITE   'RAM B/BUF CMOVE ;
;------------------------------------------------------------------------------

		header	WRITE, "WRITE", DOCOL

		dw TRAM
		dw BBUF
		dw CMOVE
		dw UNNEST

;------------------------------------------------------------------------------
; ?MISSING
; : ?MISSING   IF HERE COUNT TYPE TRUE ABORT" ?" THEN ;
;------------------------------------------------------------------------------

		voc FORTH
		header	QMISSING, "?MISSING", DOCOL

		dw QBRANCH
		dw off_13AC
		dw HERE
		dw COUNT
		dw TYPE
		dw TRUEE
		dw XABORT
		db 1,"?"
off_13AC:	dw UNNEST

;------------------------------------------------------------------------------
; DIGIT
;------------------------------------------------------------------------------

		header	DIGIT, "DIGIT"

		pop	hl
		pop	de
		ld	a, e
		sub	30h ; '0'
		jp	m, DIGIT2
		cp	0Ah
		jp	m, DIGIT1
		sub	7
		cp	0Ah
		jp	m, DIGIT2
DIGIT1:		cp	l
		jp	p, DIGIT2
		ld	e, a
		ld	hl, 0FFFFh
		jp	DPUSH
DIGIT2:		ld	l, h
		jp	DPUSH

;------------------------------------------------------------------------------
; DOUBLE?
; : DOUBLE?   DPL @ 1+ 0= NOT ;
;------------------------------------------------------------------------------

		header	DOUBLEQ, "DOUBLE?", DOCOL

		dw DPL
		dw AT
		dw ONEP
		dw ZEQU
		dw NOTT
		dw UNNEST

;------------------------------------------------------------------------------
; CONVERT
; : CONVERT   BEGIN 1+ DUP >R C@ BASE @ DIGIT 
;    WHILE SWAP BASE @ UM* DROP ROT BASE @ UM* D+ 
;    DOUBLE? IF 1 DPL +! THEN R> REPEAT DROP R> ;
;------------------------------------------------------------------------------

		header	CONVERT, "CONVERT", DOCOL

CONVERT1:	dw ONEP
		dw DUPP
		dw TOR
		dw CAT
		dw BASE
		dw AT
		dw DIGIT
		dw QBRANCH
		dw CONVERT3
		dw SWAP
		dw BASE
		dw AT
		dw UMSTAR
		dw DROP
		dw ROT
		dw BASE
		dw AT
		dw UMSTAR
		dw DPLUS
		dw DOUBLEQ
		dw QBRANCH
		dw CONVERT2
		dw ONE
		dw DPL
		dw PLUSSTORE
CONVERT2:	dw FROMR
		dw BRANCH
		dw CONVERT1
CONVERT3:	dw DROP
		dw FROMR
		dw UNNEST

;------------------------------------------------------------------------------
; (NUMBER?)
; : (NUMBER?)   0 0 ROT DUP 1+ C@ ASCII - = DUP >R - -1 DPL ! 
;   BEGIN CONVERT DUP C@ ASCII , ASCII / BETWEEN WHILE 0 DPL ! REPEAT 
;   -ROT R> IF DNEGATE THEN ROT C@ BL = ;
;------------------------------------------------------------------------------

		voc HIDDEN
		header	XNUMBERQ, "(NUMBER?)", DOCOL

		dw ZERO
		dw ZERO
		dw ROT
		dw DUPP
		dw ONEP
		dw CAT
		dw XLIT
		dw 2Dh
		dw EQUAL
		dw DUPP
		dw TOR
		dw MINUS
		dw XLIT
		dw 0FFFFh
		dw DPL
		dw STORE
off_146B:	dw CONVERT
		dw DUPP
		dw CAT
		dw XLIT
		dw 2Ch
		dw XLIT
		dw 2Fh
		dw BETWEEN
		dw QBRANCH
		dw off_1489
		dw ZERO
		dw DPL
		dw STORE
		dw BRANCH
		dw off_146B
off_1489:	dw MROT
		dw FROMR
		dw QBRANCH
		dw off_1493
		dw DNEGATE
off_1493:	dw ROT
		dw CAT
		dw BL
		dw EQUAL
		dw UNNEST

;------------------------------------------------------------------------------
; INUMBER?
; : INUMBER?   FALSE OVER COUNT OVER + SWAP 
;    DO I C@ BASE @ DIGIT NIP IF DROP TRUE LEAVE THEN LOOP 
;    IF (NUMBER?) ELSE DROP 0 0 FALSE THEN ;
;------------------------------------------------------------------------------

		header	INUMBERQ, "INUMBER?", DOCOL

		dw FALSEE
		dw OVER
		dw COUNT
		dw OVER
		dw PLUS
		dw SWAP
		dw XDO
		dw off_14D4
off_14BA:	dw IDO
		dw CAT
		dw BASE
		dw AT
		dw DIGIT
		dw NIP
		dw QBRANCH
		dw off_14D0
		dw DROP
		dw TRUEE
		dw XLEAVE
off_14D0:	dw XLOOP
		dw off_14BA
off_14D4:	dw QBRANCH
		dw off_14DE
		dw XNUMBERQ
		dw BRANCH
		dw off_14E6
off_14DE:	dw DROP
		dw ZERO
		dw ZERO
		dw FALSEE
off_14E6:	dw UNNEST

;------------------------------------------------------------------------------
; NUMBER?
; DEFER NUMBER?
; ' INUMBER? IS NUMBER? 
;------------------------------------------------------------------------------

		voc FORTH
		header	NUMBERQ, "NUMBER?", DOVEC

		dw INUMBERQ

;------------------------------------------------------------------------------
; HOLD
; : HOLD   -1 HLD +! HLD @ C! ;
;------------------------------------------------------------------------------

		header	HOLD, "HOLD", DOCOL

		dw XLIT
		dw 0FFFFh
		dw HLD
		dw PLUSSTORE
		dw HLD
		dw AT
		dw CSTORE
		dw UNNEST

;------------------------------------------------------------------------------
; SIGN
; : SIGN   0< IF ASCII - HOLD THEN ;
;------------------------------------------------------------------------------

		header	SIGN, "SIGN", DOCOL

		dw ZLESS
		dw QBRANCH
		dw off_1524
		dw XLIT
		dw 2Dh
		dw HOLD
off_1524:	dw UNNEST

;------------------------------------------------------------------------------
; <#
; : <#   PAD HLD ! ;
;------------------------------------------------------------------------------

		header	BDIGS, "<#", DOCOL

		dw PAD
		dw HLD
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; #>
; : #>   2DROP HLD @ PAD OVER - ;
;------------------------------------------------------------------------------

		header	EDIGS, "#>", DOCOL

		dw TDROP
		dw HLD
		dw AT
		dw PAD
		dw OVER
		dw MINUS
		dw UNNEST

;------------------------------------------------------------------------------
; #
; : #   BASE @ MU/MOD ROT 9 OVER < IF 7 + THEN ASCII 0 + HOLD ;
;------------------------------------------------------------------------------

		header	DIG, "#", DOCOL

		dw BASE
		dw AT
		dw MUMOD
		dw ROT
		dw XLIT
		dw 9
		dw OVER
		dw LESS
		dw QBRANCH
		dw off_156A
		dw XLIT
		dw 7
		dw PLUS
off_156A:	dw XLIT
		dw 30h
		dw PLUS
		dw HOLD
		dw UNNEST

;------------------------------------------------------------------------------
; #S
; : #S   BEGIN # 2DUP OR 0= UNTIL ;
;------------------------------------------------------------------------------

		header	DIGS, "#S", DOCOL

off_157B:	dw DIG
		dw TDUPP
		dw ORR
		dw ZEQU
		dw QBRANCH
		dw off_157B
		dw UNNEST

;------------------------------------------------------------------------------
; HEX
; : HEX   10 BASE ! ;
;------------------------------------------------------------------------------

		header	HEX, "HEX", DOCOL

		dw XLIT
		dw 10h
		dw BASE
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; DECIMAL
; : DECIMAL   0A BASE ! ;
;------------------------------------------------------------------------------

		header	DECIMAL, "DECIMAL", DOCOL

		dw XLIT
		dw 0Ah
		dw BASE
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; (U.)
; : (U.)   0 <# #S #> ;
;------------------------------------------------------------------------------

		header	XUDOT, "(U.)", DOCOL

		dw ZERO
		dw BDIGS
		dw DIGS
		dw EDIGS
		dw UNNEST

;------------------------------------------------------------------------------
; U.
; : U.   (U.) TYPE SPACE ;
;------------------------------------------------------------------------------

		header	UDOT, "U.", DOCOL

		dw XUDOT
		dw TYPE
		dw SPACE
		dw UNNEST

;------------------------------------------------------------------------------
; U.R
; : U.R   >R (U.) R> OVER - SPACES TYPE ;
;------------------------------------------------------------------------------

		header	UDOTR, "U.R", DOCOL

		dw TOR
		dw XUDOT
		dw FROMR
		dw OVER
		dw MINUS
		dw SPACES
		dw TYPE
		dw UNNEST

;------------------------------------------------------------------------------
; (.)
; : (.)   DUP ABS 0 <# #S ROT SIGN #> ;
;------------------------------------------------------------------------------

		header	XDOT, "(.)", DOCOL

		dw DUPP
		dw ABS
		dw ZERO
		dw BDIGS
		dw DIGS
		dw ROT
		dw SIGN
		dw EDIGS
		dw UNNEST

;------------------------------------------------------------------------------
; .
; : .   (.) TYPE SPACE ;
;------------------------------------------------------------------------------

		header	DOT, ".", DOCOL

		dw XDOT
		dw TYPE
		dw SPACE
		dw UNNEST

;------------------------------------------------------------------------------
; .R
; : .R   >R (.) R> OVER - SPACES TYPE ;
;------------------------------------------------------------------------------

		header	DOTR, ".R", DOCOL

		dw TOR
		dw XDOT
		dw FROMR
		dw OVER
		dw MINUS
		dw SPACES
		dw TYPE
		dw UNNEST

;------------------------------------------------------------------------------
; (D.)
; : (D.)   TUCK DABS <# #S ROT SIGN #> ;
;------------------------------------------------------------------------------

		header	XDDOT, "(D.)", DOCOL

		dw TUCK
		dw DABS
		dw BDIGS
		dw DIGS
		dw ROT
		dw SIGN
		dw EDIGS
		dw UNNEST

;------------------------------------------------------------------------------
; D.       
; : D.   (D.) TYPE SPACE ;
;------------------------------------------------------------------------------

		header	DDOT, "D.", DOCOL

		dw XDDOT
		dw TYPE
		dw SPACE
		dw UNNEST

;------------------------------------------------------------------------------
; D.R
; : D.R   >R (D.) R> OVER - SPACES TYPE ;
;------------------------------------------------------------------------------

		header	DDOTR, "D.R", DOCOL

		dw TOR
		dw XDDOT
		dw FROMR
		dw OVER
		dw MINUS
		dw SPACES
		dw TYPE
		dw UNNEST

;------------------------------------------------------------------------------
; SKIP
;------------------------------------------------------------------------------

		header	SKIP, "SKIP"

		exx
		pop	de
		pop	bc
		pop	hl
loc_1677:	ld	a, b
		or	c
		jr	z, loc_1683
		ld	a, e
		cp	(hl)
		jr	nz, loc_1683
		inc	hl
		dec	bc
		jr	loc_1677
loc_1683:	push	hl
		push	bc
		exx
		jp	NEXT

;------------------------------------------------------------------------------
; SCAN
;------------------------------------------------------------------------------

		header	SCAN, "SCAN"

		exx
		pop	de
		pop	bc
		pop	hl
		ld	a, b
		or	c
		jr	z, loc_16A1
		ld	a, e
		cpir
		jr	nz, loc_16A1
		dec	hl
		inc	bc
loc_16A1:	push	hl
		push	bc
		exx
		jp	NEXT

;------------------------------------------------------------------------------
; /STRING
; : /STRING   OVER MIN ROT OVER + -ROT - ;
;------------------------------------------------------------------------------

		header	SSTRING, "/STRING", DOCOL

		dw OVER
		dw MIN
		dw ROT
		dw OVER
		dw PLUS
		dw MROT
		dw MINUS
		dw UNNEST

;------------------------------------------------------------------------------
; PLACE
; : PLACE   2DUP >R >R 1+ SWAP MOVE R> R> C! ;
;------------------------------------------------------------------------------

		header	PLACE, "PLACE", DOCOL

		dw TDUPP
		dw TOR
		dw TOR
		dw ONEP
		dw SWAP
		dw MOVE
		dw FROMR
		dw FROMR
		dw CSTORE
		dw UNNEST

;------------------------------------------------------------------------------
; SOURCE
; : SOURCE   BLK @ ?DUP IF BLOCK B/BUF ELSE TIB #TIB @ THEN ;
;------------------------------------------------------------------------------

		header	SOURCE, "SOURCE", DOCOL

		dw BLK
		dw AT
		dw QDUPP
		dw QBRANCH
		dw SOURCE1
		dw BLOCK
		dw BBUF
		dw BRANCH
		dw SOURCE2
SOURCE1:	dw TIB
		dw NTIB
		dw AT
SOURCE2:	dw UNNEST

;------------------------------------------------------------------------------
; PARSE-WORD
; : PARSE-WORD   >R SOURCE >IN @ /STRING OVER SWAP R@ SKIP 
;    OVER SWAP R> SCAN DROP 2DUP SWAP - >R ROT - 1+ >IN +! R> ;
;------------------------------------------------------------------------------

		header	PARSWD, "PARSE-WORD", DOCOL

		dw TOR
		dw SOURCE
		dw TOIN
		dw AT
		dw SSTRING
		dw OVER
		dw SWAP
		dw RAT
		dw SKIP
		dw OVER
		dw SWAP
		dw FROMR
		dw SCAN
		dw DROP
		dw TDUPP
		dw SWAP
		dw MINUS
		dw TOR
		dw ROT
		dw MINUS
		dw ONEP
		dw TOIN
		dw PLUSSTORE
		dw FROMR
		dw UNNEST

;------------------------------------------------------------------------------
; PARSE
; : PARSE   >R SOURCE >IN @ /STRING OVER SWAP R> SCAN DROP OVER - DUP 1+ >IN +! ;
;------------------------------------------------------------------------------

		header	PARSE, "PARSE", DOCOL

		dw TOR
		dw SOURCE
		dw TOIN
		dw AT
		dw SSTRING
		dw OVER
		dw SWAP
		dw FROMR
		dw SCAN
		dw DROP
		dw OVER
		dw MINUS
		dw DUPP
		dw ONEP
		dw TOIN
		dw PLUSSTORE
		dw UNNEST

;------------------------------------------------------------------------------
; WORD
; : WORD   PARSE-WORD HERE PLACE HERE BL OVER COUNT + C! ;
;------------------------------------------------------------------------------

		header	WORD, "WORD", DOCOL

		dw PARSWD
		dw HERE
		dw PLACE
		dw HERE
		dw BL
		dw OVER
		dw COUNT
		dw PLUS
		dw CSTORE
		dw UNNEST

;------------------------------------------------------------------------------
; >TYPE
; : >TYPE   TUCK PAD SWAP CMOVE PAD SWAP TYPE ;
;------------------------------------------------------------------------------

		header	TOTYPE, ">TYPE", DOCOL

		dw TUCK
		dw PAD
		dw SWAP
		dw CMOVE
		dw PAD
		dw SWAP
		dw TYPE
		dw UNNEST

;------------------------------------------------------------------------------
; .(
; : .(   ASCII ) PARSE >TYPE ; IMMEDIATE
;------------------------------------------------------------------------------

		header	DOTCOMNT, ".\x28", DOCOL, IMMEDIATE

		dw XLIT
		dw 29h		; ')'
		dw PARSE
		dw TOTYPE
		dw UNNEST

;------------------------------------------------------------------------------
; (
; : (   ASCII ) PARSE 2DROP ; IMMEDIATE
;------------------------------------------------------------------------------

		header	COMMENT, "\x28", DOCOL, IMMEDIATE

		dw XLIT
		dw 29h		; ')'
		dw PARSE
		dw TDROP
		dw UNNEST

;------------------------------------------------------------------------------
; HASH
;------------------------------------------------------------------------------

		header	HASH, "HASH"

		pop	de
		pop	hl
		inc	hl
		ld	a, (hl)
		and	3
		rla		; * 2
		ld	l, a
		ld	h, 0
		add	hl, de
		jp	HPUSH

;------------------------------------------------------------------------------
; (FIND)
;------------------------------------------------------------------------------

		voc HIDDEN
		header	XFIND, "(FIND)"

		exx
		pop	bc
loc_17EF:	ld	a, b
		or	c
		jr	z, loc_181B
		ld	d, b
		ld	e, c
		inc	de
		inc	de
		pop	hl
		push	hl
		ld	a, (de)
		xor	(hl)
		and	3Fh ; '?'
		jr	nz, loc_1820
loc_17FF:	inc	de
		inc	hl
		ld	a, (de)
		xor	(hl)
		jr	z, loc_17FF
		and	7Fh ; ''
		jr	nz, loc_1820
		pop	hl
		inc	de
		push	de
		inc	bc
		inc	bc
		ld	a, (bc)
		and	40h ; '@'
		jr	z, loc_1818
		ld	bc, 1
		jr	loc_181B
loc_1818:	ld	bc, 0FFFFh
loc_181B:	push	bc
		exx
		jp	NEXT
loc_1820:	ld	h, b
		ld	l, c
		ld	c, (hl)
		inc	hl
		ld	b, (hl)
		jr	loc_17EF

;------------------------------------------------------------------------------
; FIND
; : FIND   PRIOR OFF FALSE #VOCS 0 DO
;    DROP CONTEXT I 2* + @ DUP 
;    IF DUP PRIOR @ OVER PRIOR ! = 
;    IF DROP FALSE ELSE OVER SWAP HASH @ (FIND) DUP ?LEAVE THEN THEN LOOP ;
;------------------------------------------------------------------------------

		voc FORTH
		header	FIND, "FIND", DOCOL

		dw PRIOR
		dw OFF
		dw FALSEE
		dw VOCS
		dw ZERO
		dw XDO
		dw FIND4
FIND1:		dw DROP
		dw CONTEXT
		dw IDO
		dw TTIMES
		dw PLUS
		dw AT
		dw DUPP
		dw QBRANCH
		dw FIND3
		dw DUPP
		dw PRIOR
		dw AT
		dw OVER
		dw PRIOR
		dw STORE
		dw EQUAL
		dw QBRANCH
		dw FIND2
		dw DROP
		dw FALSEE
		dw BRANCH
		dw FIND3
FIND2:		dw OVER
		dw SWAP
		dw HASH
		dw AT
		dw XFIND
		dw DUPP
		dw XQLEAVE
FIND3:		dw XLOOP
		dw FIND1
FIND4:		dw UNNEST

;------------------------------------------------------------------------------
; DEFINED
; : DEFINED   BL WORD FIND ;
;------------------------------------------------------------------------------

		header	DEFINED, "DEFINED", DOCOL

		dw BL
		dw WORD
		dw FIND
		dw UNNEST

;------------------------------------------------------------------------------
; STATUS
; DEFER STATUS
; ' CR IS STATUS
;------------------------------------------------------------------------------

		header	STATUS, "STATUS", DOVEC

		dw CR

;------------------------------------------------------------------------------
; ?STACK
; : ?STACK   SP@ SP0 @ SWAP U< ABORT" stack underflow" 
;    SP@ PAD U< ABORT" stack overflow" ;
;------------------------------------------------------------------------------

		header	QSTACK, "?STACK", DOCOL

		dw SPAT
		dw SPZ
		dw AT
		dw SWAP
		dw ULESS
		dw XABORT
		db 15,"stack underflow"
		dw SPAT
		dw PAD
		dw ULESS
		dw XABORT
		db 14,"stack overflow"
		dw UNNEST

;------------------------------------------------------------------------------
; HANDLE
; DEFER HANDLE 
; ' (INTERPRET) IS HANDLE
;------------------------------------------------------------------------------

		voc HIDDEN
		header	HANDLE, "HANDLE", DOVEC

		dw XINTRPRT

;------------------------------------------------------------------------------
; (INTERPRET)
; : (INTERPRET)   FIND IF EXECUTE ELSE NUMBER? NOT ?MISSING DOUBLE? NOT IF DROP THEN THEN ;
;------------------------------------------------------------------------------

		header	XINTRPRT, "(INTERPRET)", DOCOL

		dw FIND
		dw QBRANCH
		dw off_1908
		dw EXECUTE
		dw BRANCH
		dw off_1918
off_1908:	dw NUMBERQ
		dw NOTT
		dw QMISSING
		dw DOUBLEQ
		dw NOTT
		dw QBRANCH
		dw off_1918
		dw DROP
off_1918:	dw UNNEST

;------------------------------------------------------------------------------
; INTERPRET
; : INTERPRET   BEGIN ?STACK BL WORD DUP C@ WHILE HANDLE REPEAT DROP ;
;------------------------------------------------------------------------------

		voc FORTH
		header	INTRPRT, "INTERPRET", DOCOL

off_1928:	dw QSTACK
		dw BL
		dw WORD
		dw DUPP
		dw CAT
		dw QBRANCH
		dw off_193C
		dw HANDLE
		dw BRANCH
		dw off_1928
off_193C:	dw DROP
		dw UNNEST

;------------------------------------------------------------------------------
; ALLOT
; : ALLOT   DP +! ;
;------------------------------------------------------------------------------

		header	ALLOT, "ALLOT", DOCOL

		dw DP
		dw PLUSSTORE
		dw UNNEST

;------------------------------------------------------------------------------
; ,
; : ,   HERE ! 2 ALLOT ;
;------------------------------------------------------------------------------

		header	COMMA, ",", DOCOL

		dw HERE
		dw STORE
		dw TWO
		dw ALLOT
		dw UNNEST

;------------------------------------------------------------------------------
; C,
; : C,   HERE C! 1 ALLOT ;
;------------------------------------------------------------------------------

		header	CCOMMA, "C,", DOCOL

		dw HERE
		dw CSTORE
		dw ONE
		dw ALLOT
		dw UNNEST

;------------------------------------------------------------------------------
; COMPILE
; : COMPILE   R> DUP 2+ >R @ , ;
;------------------------------------------------------------------------------

		header	COMPILE, "COMPILE", DOCOL

		dw FROMR
		dw DUPP
		dw TWOP
		dw TOR
		dw AT
		dw COMMA
		dw UNNEST

;------------------------------------------------------------------------------
; IMMEDIATE
; HEX : IMMEDIATE   40 ( Precedence bit) LAST @ CSET ;
;------------------------------------------------------------------------------

		header	IMMEDIAT, "IMMEDIATE", DOCOL

		dw XLIT
		dw 40h
		dw LAST
		dw AT
		dw CSET
		dw UNNEST

;------------------------------------------------------------------------------
; LITERAL
; : LITERAL   COMPILE (LIT) , ; IMMEDIATE
;------------------------------------------------------------------------------

		header	LITERAL, "LITERAL", DOCOL, IMMEDIATE

		dw COMPILE
		dw XLIT
		dw COMMA
		dw UNNEST

;------------------------------------------------------------------------------
; DLITERAL
; : DLITERAL   SWAP [COMPILE] LITERAL [COMPILE] LITERAL ; IMMEDIATE
;------------------------------------------------------------------------------

		header	DLITERAL, "DLITERAL", DOCOL, IMMEDIATE

		dw SWAP
		dw LITERAL
		dw LITERAL
		dw UNNEST

;------------------------------------------------------------------------------
; '
; : '   DEFINED 0= ?MISSING ;
;------------------------------------------------------------------------------

		header	TICK, "'", DOCOL

		dw DEFINED
		dw ZEQU
		dw QMISSING
		dw UNNEST

;------------------------------------------------------------------------------
; [']
; : [']   ' [COMPILE] LITERAL ; IMMEDIATE
;------------------------------------------------------------------------------

		header	BTICK, "[']", DOCOL, IMMEDIATE

		dw TICK
		dw LITERAL
		dw UNNEST

;------------------------------------------------------------------------------
; [COMPILE]
; : [COMPILE]   ' , ; IMMEDIATE
;------------------------------------------------------------------------------

		header	BCOMPILE, "[COMPILE]", DOCOL, IMMEDIATE

		dw TICK
		dw COMMA
		dw UNNEST

;------------------------------------------------------------------------------
; (")
; : (")   R> COUNT 2DUP + >R ;
;------------------------------------------------------------------------------

		voc HIDDEN
		header	XQUOTE, "(\i)", DOCOL

		dw FROMR
		dw COUNT
		dw TDUPP
		dw PLUS
		dw TOR
		dw UNNEST

;------------------------------------------------------------------------------
; (.")
; : (.")   R> COUNT 2DUP + >R TYPE ;
;------------------------------------------------------------------------------

		header	XDOTQ, "(.\i)", DOCOL

		dw FROMR
		dw COUNT
		dw TDUPP
		dw PLUS
		dw TOR
		dw TYPE
		dw UNNEST

;------------------------------------------------------------------------------
; ,"
; : ,"   ASCII " PARSE TUCK HERE PLACE 1+ ALLOT ;
;------------------------------------------------------------------------------

		header	COMMAQ, ",\i", DOCOL

		dw XLIT
		dw 22h
		dw PARSE
		dw TUCK
		dw HERE
		dw PLACE
		dw ONEP
		dw ALLOT
		dw UNNEST

;------------------------------------------------------------------------------
; ."
; : ."   COMPILE (.") ," ; IMMEDIATE
;------------------------------------------------------------------------------

		voc FORTH
		header	DOTQ, ".\i", DOCOL, IMMEDIATE

		dw COMPILE
		dw XDOTQ
		dw COMMAQ
		dw UNNEST

;------------------------------------------------------------------------------
; "
; : "   COMPILE (") ," ; IMMEDIATE
;------------------------------------------------------------------------------

		header	QUOTE, "\i", DOCOL, IMMEDIATE

		dw COMPILE
		dw XQUOTE
		dw COMMAQ
		dw UNNEST

;------------------------------------------------------------------------------
; WHERE
; DEFER WHERE
; ' NOOP IS WHERE
;------------------------------------------------------------------------------

		header	WHERE, "WHERE", DOVEC

		dw NOOP

;------------------------------------------------------------------------------
; ?ERROR
; DEFER ?ERROR
; ' (?ERROR) IS ?ERROR
;------------------------------------------------------------------------------

		header	QERROR, "?ERROR", DOVEC

		dw XQERROR

;------------------------------------------------------------------------------
; (ABORT")
; : (ABORT")   R@ COUNT ROT ?ERROR R> COUNT + >R ;
;------------------------------------------------------------------------------

		voc HIDDEN
		header	XABORT, "(ABORT\i)", DOCOL

		dw RAT
		dw COUNT
		dw ROT
		dw QERROR
		dw FROMR
		dw COUNT
		dw PLUS
		dw TOR
		dw UNNEST

;------------------------------------------------------------------------------
; ABORT"
; : ABORT"   COMPILE (ABORT") ," ; IMMEDIATE
;------------------------------------------------------------------------------

		voc FORTH
		header	ABORTQ, "ABORT\i", DOCOL, IMMEDIATE

		dw COMPILE
		dw XABORT
		dw COMMAQ
		dw UNNEST

;------------------------------------------------------------------------------
; !CSP
; : !CSP   SP@ CSP ! ;
;------------------------------------------------------------------------------

		header	STCSP, "!CSP", DOCOL

		dw SPAT
		dw CSP
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; ?CSP
; : ?CSP   SP@ CSP @ = NOT (ABORT") compilation uncorrect" ;
;------------------------------------------------------------------------------

		header	QCSP, "?CSP", DOCOL

		dw SPAT
		dw CSP
		dw AT
		dw EQUAL
		dw NOTT
		dw XABORT
		db 21,"compilation uncorrect"
		dw UNNEST

;------------------------------------------------------------------------------
; N>LINK
; : N>LINK   2- ;
;------------------------------------------------------------------------------

		header	NTOLINK, "N>LINK", DOCOL

		dw TWOM
		dw UNNEST

;------------------------------------------------------------------------------
; L>NAME
; : L>NAME   2+ ;
;------------------------------------------------------------------------------

		header	LTONAME, "L>NAME", DOCOL

		dw TWOP
		dw UNNEST

;------------------------------------------------------------------------------
; BODY>
; : BODY>   2- ;
;------------------------------------------------------------------------------

		header	FROMBODY, "BODY>", DOCOL

		dw TWOM
		dw UNNEST

;------------------------------------------------------------------------------
; NAME>
;------------------------------------------------------------------------------

		header	FROMNAME, "NAME>"

		pop	hl
loc_1B1F:	inc	hl
		bit	7, (hl)
		jp	z, loc_1B1F
		inc	hl
		jp	HPUSH

;------------------------------------------------------------------------------
; LINK>
; : LINK>   L>NAME NAME> ;
;------------------------------------------------------------------------------

		header	FROMLINK, "LINK>", DOCOL

		dw LTONAME
		dw FROMNAME
		dw UNNEST

;------------------------------------------------------------------------------
; >BODY
; : >BODY   2+ ;
;------------------------------------------------------------------------------

		header	TOBODY, ">BODY", DOCOL

		dw TWOP
		dw UNNEST

;------------------------------------------------------------------------------
; >NAME
;------------------------------------------------------------------------------

		header	TONAME, ">NAME"

		pop	hl
		dec	hl
loc_1B53:	dec	hl
		bit	7, (hl)
		jp	z, loc_1B53
		jp	HPUSH

;------------------------------------------------------------------------------
; >LINK
; : >LINK   >NAME N>LINK ;
;------------------------------------------------------------------------------

		header	TOLINK, ">LINK", DOCOL

		dw TONAME
		dw NTOLINK
		dw UNNEST

;------------------------------------------------------------------------------
; HIDE
; : HIDE   LAST @ DUP N>LINK @ SWAP CURRENT @ HASH ! ;
;------------------------------------------------------------------------------

		header	HIDE, "HIDE", DOCOL

		dw LAST
		dw AT
		dw DUPP
		dw NTOLINK
		dw AT
		dw SWAP
		dw CURRENT
		dw AT
		dw HASH
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; REVEAL
; : REVEAL LAST @ DUP N>LINK SWAP CURRENT @ HASH ! ;
;------------------------------------------------------------------------------

		header	REVEAL, "REVEAL", DOCOL

		dw LAST
		dw AT
		dw DUPP
		dw NTOLINK
		dw SWAP
		dw CURRENT
		dw AT
		dw HASH
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; HEADER
; HEX : HEADER   HERE 0 , HERE LAST ! DEFINED WARNING @ AND 
;   IF HERE COUNT TYPE (.")  is redefined " THEN 
;   DROP HERE CURRENT @ HASH DUP @ HERE 2- ROT ! SWAP ! 
;   HERE DUP C@ WIDTH @ MIN 1+ ALLOT 80 SWAP CSET 80 HERE 1- CSET ;
;------------------------------------------------------------------------------

		voc HIDDEN
		header	HEADER, "HEADER", DOCOL

		dw HERE
		dw ZERO
		dw COMMA
		dw HERE
		dw LAST
		dw STORE
		dw DEFINED
		dw WARNING
		dw AT
		dw ANDD
		dw QBRANCH
		dw off_1BE4
		dw HERE
		dw COUNT
		dw TYPE
		dw XDOTQ
		db 14," is redefined "
off_1BE4:	dw DROP
		dw HERE
		dw CURRENT
		dw AT
		dw HASH
		dw DUPP
		dw AT
		dw HERE
		dw TWOM
		dw ROT
		dw STORE
		dw SWAP
		dw STORE
		dw HERE
		dw DUPP
		dw CAT
		dw WIDTH
		dw AT
		dw MIN
		dw ONEP
		dw ALLOT
		dw XLIT
		dw 80h
		dw SWAP
		dw CSET
		dw XLIT
		dw 80h
		dw HERE
		dw ONEM
		dw CSET
		dw UNNEST

;------------------------------------------------------------------------------
; CREATE
; : CREATE HEADER @@dovar , ;
;------------------------------------------------------------------------------

		voc FORTH
		header	CREATE, "CREATE", DOCOL

		dw HEADER
		dw XLIT
		dw DOVAR
		dw COMMA
		dw UNNEST

;------------------------------------------------------------------------------
; (COMPILE)
; : (COMPILE)   FIND ?DUP IF 0> IF EXECUTE ELSE , THEN
;    ELSE NUMBER? NOT ?MISSING DOUBLE? IF DLITERAL ELSE DROP LITERAL THEN THEN ;
;------------------------------------------------------------------------------

		voc HIDDEN
		header	XCOMPILE, "(COMPILE)", DOCOL

		dw FIND
		dw QDUPP
		dw QBRANCH		; if
		dw off_1C5F
		dw ZGREAT
		dw QBRANCH		; if
		dw off_1C59
		dw EXECUTE
		dw BRANCH		
		dw off_1C5B
off_1C59:	dw COMMA		; else	
off_1C5B:	dw BRANCH		
		dw off_1C75
off_1C5F:	dw NUMBERQ		; then else
		dw NOTT
		dw QMISSING
		dw DOUBLEQ
		dw QBRANCH		; if
		dw off_1C71
		dw DLITERAL
		dw BRANCH		
		dw off_1C75
off_1C71:	dw DROP			; else
		dw LITERAL
off_1C75:	dw UNNEST		; then then

;------------------------------------------------------------------------------
; [
; : [   STATE OFF ['] (INTERPRET) (IS) HANDLE ; IMMEDIATE
;------------------------------------------------------------------------------

		voc FORTH
		header	LBRACKET, "[", DOCOL, IMMEDIATE

		dw STATE
		dw OFF
		dw XLIT
		dw XINTRPRT
		dw XIS
		dw HANDLE
		dw UNNEST

;------------------------------------------------------------------------------
; ]
; : ]   STATE ON ['] (COMPILE) (IS) HANDLE ;
;------------------------------------------------------------------------------

		header	RBRACKET, "]", DOCOL

		dw STATE
		dw ON
		dw XLIT
		dw XCOMPILE
		dw XIS
		dw HANDLE
		dw UNNEST

;------------------------------------------------------------------------------
; ASSEMBLER
;------------------------------------------------------------------------------

		header	VASSEMBL, "ASSEMBLER", DOVOC

		dw lstlnk_C
		dw lstlnk_D
		dw lstlnk_E
		dw lstlnk_F
VASSEMBLL:	dw VIOL

;------------------------------------------------------------------------------
; (;USES)
; : (;USES)   R> @ LAST @ NAME> ! ;
;------------------------------------------------------------------------------

		voc HIDDEN
		header	XSUSES, "(;USES)", DOCOL

		dw FROMR
		dw AT
		dw LAST
		dw AT
		dw FROMNAME
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; (;CODE)
; : (;CODE)   R> LAST @ NAME> ! ;
;------------------------------------------------------------------------------

		header	XSCODE, "(;CODE)", DOCOL

		dw FROMR
		dw LAST
		dw AT
		dw FROMNAME
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; ;USES
; : ;USES   ?CSP COMPILE (;USES) [COMPILE] [ REVEAL ASSEMBLER ; IMMEDIATE
;------------------------------------------------------------------------------

		voc FORTH
		header	SUSES, ";USES", DOCOL, IMMEDIATE

		dw QCSP
		dw COMPILE
		dw XSUSES
		dw LBRACKET
		dw REVEAL
		dw VASSEMBL
		dw UNNEST

;------------------------------------------------------------------------------
; ;CODE
; : ;CODE   ?CSP COMPILE (;CODE) [COMPILE] [ REVEAL ASSEMBLER ; IMMEDIATE
;------------------------------------------------------------------------------

		header	SCODE, ";CODE", DOCOL, IMMEDIATE

		dw QCSP
		dw COMPILE
		dw XSCODE
		dw LBRACKET
		dw REVEAL
		dw VASSEMBL
		dw UNNEST

;------------------------------------------------------------------------------
; >DOES
; @@dodoe CONSTANT >DOES
;------------------------------------------------------------------------------

		header	TODOES, ">DOES", DOCON

		dw DODOE

;------------------------------------------------------------------------------
; DOES>
; HEX : DOES> COMPILE (;CODE) 0CD ( call) C, >DOES , ; IMMEDIATE
;------------------------------------------------------------------------------

		header	FROMDOES, "DOES>", DOCOL, IMMEDIATE

		dw COMPILE
		dw XSCODE
		dw XLIT
		dw 0CDh
		dw CCOMMA
		dw TODOES
		dw COMMA
		dw UNNEST

;------------------------------------------------------------------------------
; :
; : !CSP   CURRENT @ CONTEXT ! CREATE HIDE ] ;USES @@docol ,
;------------------------------------------------------------------------------

		header	COLON, ":", DOCOL

		dw STCSP
		dw CURRENT
		dw AT
		dw CONTEXT
		dw STORE
		dw CREATE
		dw HIDE
		dw RBRACKET
		dw XSUSES
		dw DOCOL

;------------------------------------------------------------------------------
; ;
; : ;   ?CSP COMPILE UNNEST REVEAL [COMPILE] [ ; IMMEDIATE
;------------------------------------------------------------------------------

		header	SEMIC, ";", DOCOL, IMMEDIATE

		dw QCSP
		dw COMPILE
		dw UNNEST
		dw REVEAL
		dw LBRACKET
		dw UNNEST

;------------------------------------------------------------------------------
; RECURSE
; : RECURSE   LAST @ NAME> , ; IMMEDIATE
;------------------------------------------------------------------------------

		header	RECURSE, "RECURSE", DOCOL, IMMEDIATE

		dw LAST
		dw AT
		dw FROMNAME
		dw COMMA
		dw UNNEST

;------------------------------------------------------------------------------
; CONSTANT
; : CONSTANT CREATE , ;USES @@docon ,
;------------------------------------------------------------------------------

		header	CONSTANT, "CONSTANT", DOCOL

		dw CREATE
		dw COMMA
		dw XSUSES
		dw DOCON

;------------------------------------------------------------------------------
; VARIABLE
; : VARIABLE CREATE 0 , ;USES @@dovar ,
;------------------------------------------------------------------------------

		header	VARIABLE, "VARIABLE", DOCOL

		dw CREATE
		dw ZERO
		dw COMMA
		dw XSUSES
		dw DOVAR

;------------------------------------------------------------------------------
; 2CONSTANT
; : 2CONSTANT   CREATE , , DOES> 2@ ; DROP
;------------------------------------------------------------------------------

		header	TCONSTANT, "2CONSTANT", DOCOL

		dw CREATE
		dw COMMA
		dw COMMA
		dw XSCODE
;
		call	DODOE
		dw TAT
		dw UNNEST

;------------------------------------------------------------------------------
; 2VARIABLE
; : 2VARIABLE   0 0 2CONSTANT DOES> ; DROP
;------------------------------------------------------------------------------

		header	TVARIABLE, "2VARIABLE", DOCOL

		dw ZERO
		dw ZERO
		dw TCONSTANT
		dw XSCODE
;
		call	DODOE
		dw UNNEST

;------------------------------------------------------------------------------
; CRASH
; : CRASH TRUE ABORT" undefined execution vector" ;
;------------------------------------------------------------------------------

		header	CRASH, "CRASH", DOCOL

		dw TRUEE
		dw XABORT
		db 26,"undefined execution vector"
		dw UNNEST

;------------------------------------------------------------------------------
; DEFER
; : DEFER CREATE ['] CRASH , ;USES @@dovec ,
;------------------------------------------------------------------------------

		header	DEFER, "DEFER", DOCOL

		dw CREATE
		dw XLIT
		dw CRASH
		dw COMMA
		dw XSUSES
;		
		dw DOVEC

;------------------------------------------------------------------------------
; #THREADS
; 4 CONSTANT #THREADS
;------------------------------------------------------------------------------

		header	NUMTHREADS, "#THREADS", DOCON

		dw 4

;------------------------------------------------------------------------------
; TRIM
; : TRIM   #THREADS 0 DO 2DUP @ BEGIN 2DUP SWAP U< NOT WHILE @ REPEAT 
;    NIP OVER ! 2+ LOOP 2DROP ;
;------------------------------------------------------------------------------

		voc HIDDEN
		header	TRIM, "TRIM", DOCOL

		dw NUMTHREADS
		dw ZERO
		dw XDO
		dw off_1E68
off_1E46:	dw TDUPP
		dw AT
off_1E4A:	dw TDUPP	; begin
		dw SWAP
		dw ULESS
		dw NOTT
		dw QBRANCH	; while
		dw off_1E5C
		dw AT
		dw BRANCH	; repeat
		dw off_1E4A
off_1E5C:	dw NIP
		dw OVER
		dw STORE
		dw TWOP
		dw XLOOP
		dw off_1E46
off_1E68:	dw TDROP
		dw UNNEST

;------------------------------------------------------------------------------
; (FORGET)
; : (FORGET)   DUP FENCE @ U< ABORT" protected " 
;    DUP VOC-LINK @ BEGIN 2DUP U< WHILE @ REPEAT 
;    DUP VOC-LINK ! NIP 
;    BEGIN DUP WHILE 2DUP #THREADS 2* - TRIM @ REPEAT DROP DP ! ;
;------------------------------------------------------------------------------

		header	XFORGET, "(FORGET)", DOCOL

		dw DUPP
		dw FENCE
		dw AT
		dw ULESS
		dw XABORT
		db 10,"protected "
		dw DUPP
		dw VOCLINK
		dw AT
off_1E94:	dw TDUPP
		dw ULESS
		dw QBRANCH
		dw off_1EA2
		dw AT
		dw BRANCH
		dw off_1E94
off_1EA2:	dw DUPP
		dw VOCLINK
		dw STORE
		dw NIP
off_1EAA:	dw DUPP
		dw QBRANCH
		dw off_1EC0
		dw TDUPP
		dw NUMTHREADS
		dw TTIMES
		dw MINUS
		dw TRIM
		dw AT
		dw BRANCH
		dw off_1EAA
off_1EC0:	dw DROP
		dw DP
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; FORGET
; : FORGET   BL WORD DUP CURRENT @ HASH @ (FIND) 0= ?MISSING >LINK (FORGET) ;
;------------------------------------------------------------------------------

		voc FORTH
		header	FORGET, "FORGET", DOCOL

		dw BL
		dw WORD
		dw DUPP
		dw CURRENT
		dw AT
		dw HASH
		dw AT
		dw XFIND
		dw ZEQU
		dw QMISSING
		dw TOLINK
		dw XFORGET
		dw UNNEST

;------------------------------------------------------------------------------
; AVOC
; VARIABLE AVOC
;------------------------------------------------------------------------------

		header	AVOC, "AVOC", DOVAR

		dw VIO1

;------------------------------------------------------------------------------
; CODE
; : CODE   CREATE HIDE HERE DUP 2- ! CONTEXT @ AVOC ! ASSEMBLER ;
;------------------------------------------------------------------------------

		header	CODE, "CODE", DOCOL

		dw CREATE
		dw HIDE
		dw HERE
		dw DUPP
		dw TWOM
		dw STORE
		dw CONTEXT
		dw AT
		dw AVOC
		dw STORE
		dw VASSEMBL
		dw UNNEST

;------------------------------------------------------------------------------
; LABEL
; : LABEL   CREATE HIDE CONTEXT @ AVOC ! ASSEMBLER ;
;------------------------------------------------------------------------------

		header	LABEL, "LABEL", DOCOL

		dw CREATE
		dw HIDE
		dw CONTEXT
		dw AT
		dw AVOC
		dw STORE
		dw VASSEMBL
		dw UNNEST

;------------------------------------------------------------------------------
; END-CODE
; ASSEMBLER DEFINITIONS
; : END-CODE   AVOC @ CONTEXT ! REVEAL ;
;------------------------------------------------------------------------------

		voc ASSEMBLER
		header	ENDCODE, "END-CODE", DOCOL

		dw AVOC
		dw AT
		dw CONTEXT
		dw STORE
		dw REVEAL
		dw UNNEST

;------------------------------------------------------------------------------
; VOCABULARY
; FORTH DEFINITIONS
; : VOCABULARY   CREATE #THREADS 0 DO 0 , LOOP 
;    HERE VOC-LINK @ , VOC-LINK ! DOES> CONTEXT ! ;
;------------------------------------------------------------------------------

		voc FORTH
		header	VOCABULARY, "VOCABULARY", DOCOL

		dw CREATE
		dw NUMTHREADS
		dw ZERO
		dw XDO
		dw off_1F6D
off_1F65:	dw ZERO
		dw COMMA
		dw XLOOP
		dw off_1F65
off_1F6D:	dw HERE
		dw VOCLINK
		dw AT
		dw COMMA
		dw VOCLINK
		dw STORE
		dw XSCODE
;
DOVOC:		call	DODOE
		dw CONTEXT
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; DEFINITIONS
; : DEFINITIONS CONTEXT @ CURRENT ! ;
;------------------------------------------------------------------------------

		header	DEFIN, "DEFINITIONS", DOCOL

		dw CONTEXT
		dw AT
		dw CURRENT
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; #USER
; VARIABLE #USER
;------------------------------------------------------------------------------

		header	NUMUSER, "#USER", DOVAR

		dw 1Ch

;------------------------------------------------------------------------------
; VUSER
; VOCABULARY USER
;------------------------------------------------------------------------------

		header	VUSER, "USER", DOVOC

		dw lstlnk_10
		dw lstlnk_11
		dw lstlnk_12
		dw lstlnk_13
VUSERL:		dw VASSEMBLL

;------------------------------------------------------------------------------
; ALLOT
; USER DEFINITIONS
; : ALLOT   DP +! ;
;------------------------------------------------------------------------------

		voc USER
		header	ALLOT2, "ALLOT", DOCOL

		dw NUMUSER
		dw PLUSSTORE
		dw UNNEST

;------------------------------------------------------------------------------
; CREATE
; : CREATE   CREATE #USER @ , ;USES @@douse ,
;------------------------------------------------------------------------------
		
		header	CREATE2, "CREATE", DOCOL

		dw CREATE
		dw NUMUSER
		dw AT
		dw COMMA
		dw XSUSES
		dw DOUSE

;------------------------------------------------------------------------------
; VARIABLE
; : VARIABLE   CREATE 2 ALLOT ;
;------------------------------------------------------------------------------

		header	VARIABLE2, "VARIABLE", DOCOL

		dw CREATE2
		dw TWO
		dw ALLOT2
		dw UNNEST

;------------------------------------------------------------------------------
; DEFER
; : DEFER   VARIABLE ;USES @@douvec ,
;------------------------------------------------------------------------------

		header	DEFER2, "DEFER", DOCOL

		dw VARIABLE2
		dw XSUSES
		dw DOUVEC

;------------------------------------------------------------------------------
; QUIT
; FORTH DEFINITIONS
; : QUIT  BLK OFF [COMPILE] [ 
;     BEGIN RP0 @ RP! STATUS QUERY INTERPRET 
;     STATE @ NOT IF ." ok" THEN AGAIN ;
;------------------------------------------------------------------------------

		voc FORTH
		header	QUIT, "QUIT", DOCOL

		dw BLK
		dw OFF
		dw LBRACKET
off_2018:	dw RPZ
		dw AT
		dw RPSTORE
		dw STATUS
		dw QUERY
		dw INTRPRT
		dw STATE
		dw AT
		dw NOTT
		dw QBRANCH
		dw off_2033
		dw XDOTQ
		db 2,"ok"
off_2033:	dw BRANCH
		dw off_2018
		dw UNNEST

;------------------------------------------------------------------------------
; >IS
; : >IS   DUP @ DUP @@douse = SWAP DUP @@douvec = SWAP DROP OR 
;     IF >BODY @ UP @ + ELSE >BODY THEN ;
;------------------------------------------------------------------------------

		header	TOIS, ">IS", DOCOL

		dw DUPP
		dw AT
		dw DUPP
		dw XLIT
		dw DOUSE
		dw EQUAL
		dw SWAP
		dw DUPP
		dw XLIT
		dw DOUVEC
		dw EQUAL
		dw SWAP
		dw DROP
		dw ORR
		dw QBRANCH
		dw off_206F
		dw TOBODY
		dw AT
		dw UP
		dw AT
		dw PLUS
		dw BRANCH
		dw off_2071
off_206F:	dw TOBODY
off_2071:	dw UNNEST

;------------------------------------------------------------------------------
; (IS)
; : (IS)   R@ @ >IS ! R> 2+ >R ;
;------------------------------------------------------------------------------

		header	XIS, "(IS)", DOCOL

		dw RAT
		dw AT
		dw TOIS
		dw STORE
		dw FROMR
		dw TWOP
		dw TOR
		dw UNNEST

;------------------------------------------------------------------------------
; IS
; : IS   STATE @ IF COMPILE (IS) ELSE ' >IS ! THEN ; IMMEDIATE
;------------------------------------------------------------------------------

		header	IS, "IS", DOCOL, IMMEDIATE

		dw STATE
		dw AT
		dw QBRANCH
		dw off_20A3
		dw COMPILE
		dw XIS
		dw BRANCH
		dw off_20A9
off_20A3:	dw TICK
		dw TOIS
		dw STORE
off_20A9:	dw UNNEST

;------------------------------------------------------------------------------
; (?ERROR)
; HIDDEN DEFINITIONS
; : (?ERROR)   IF >R >R SP0 @ SP! PRINTING OFF 
;     BLK @ IF >IN @ BLK @ WHERE THEN 
;     R> R> SPACE TYPE SPACE QUIT ELSE 2DROP THEN ;
;------------------------------------------------------------------------------

		voc HIDDEN
		header	XQERROR, "(?ERROR)", DOCOL

		dw QBRANCH
		dw off_20EC
		dw TOR
		dw TOR
		dw SPZ
		dw AT
		dw SPSTORE
		dw PRINTING
		dw OFF
		dw BLK
		dw AT
		dw QBRANCH
		dw off_20DC
		dw TOIN
		dw AT
		dw BLK
		dw AT
		dw WHERE
off_20DC:	dw FROMR
		dw FROMR
		dw SPACE
		dw TYPE
		dw SPACE
		dw QUIT
		dw BRANCH
		dw off_20EE
off_20EC:	dw TDROP
off_20EE:	dw UNNEST

;------------------------------------------------------------------------------
; ABORT
; FORTH DEFINITIONS
; : ABORT   SP0 @ SP! QUIT ;
;------------------------------------------------------------------------------

		voc FORTH
		header	ABORT, "ABORT", DOCOL

		dw SPZ
		dw AT
		dw SPSTORE
		dw QUIT
		dw UNNEST

;------------------------------------------------------------------------------
; FORTH-83
; : FORTH-83 ;
;------------------------------------------------------------------------------

		header	FORTH83, "FORTH-83", DOCOL

		dw UNNEST

;------------------------------------------------------------------------------
; .VERSION
; : .VERSION   CR ." Z80 FORTH 83  V1.3" CR ." im Auftrag der AIG Forth" CR 
;     ." Th. Beierlein  (Juli 88)" CR ;
;------------------------------------------------------------------------------

		header	PVERSION, ".VERSION", DOCOL

		dw CR
		dw XDOTQ
		db 18,"Z80 FORTH 83  V1.3"
		dw CR
		dw XDOTQ
		db 24,"im Auftrag der AIG Forth"
		dw CR
		dw XDOTQ
		db 24,"Th. Beierlein  (Juli 88)"
		dw CR
		dw UNNEST

;------------------------------------------------------------------------------
; BOOT
; DEFER BOOT
; ' HELLO IS BOOT
;------------------------------------------------------------------------------

		header	BOOT, "BOOT", DOVEC

		dw HELLO

;------------------------------------------------------------------------------
; COLD
; : COLD   BOOT ABORT ;
;------------------------------------------------------------------------------

		header	COLD, "COLD", DOCOL

COLD1:		dw BOOT
		dw ABORT
		dw UNNEST

;------------------------------------------------------------------------------
; WARM
; : WARM   TRUE ABORT" Warmstart" ;
;------------------------------------------------------------------------------

		header	WARM, "WARM", DOCOL

WARM1:		dw TRUEE
		dw XABORT
		db 9,"Warmstart"
		dw UNNEST

;------------------------------------------------------------------------------
; warm start
;------------------------------------------------------------------------------

wrm:		ld	bc, WARM1	; (IP)
		jp	NEXT

;------------------------------------------------------------------------------
; cold start
;------------------------------------------------------------------------------

cld1:		ld	hl, (init_top)
		ld	de, (BBUF1)
		and	a
		sbc	hl, de
		ld	(FIRSTC), hl	; FIRST := init_top - B/BUF
;
		push	hl
		pop	iy		; RSP auf init_top - B/BUF
		ex	de, hl
		ld	hl, (UPVAR)
		ld	bc, 8
		add	hl, bc
		ld	(hl), e
		inc	hl
		ld	(hl), d		; User Var RP0 := init_top - B/BUF
;
		ex	de, hl
		ld	bc, 200		; Platz reservieren
		and	a
		sbc	hl, bc
		ld	(TTIBV), hl	; 'TIB := RP0-200
;
		ex	de, hl
		dec	hl
		dec	hl
		ld	(hl), d
		dec	hl
		ld	(hl), e		; User Var SP0 := RP0-200
;
		ex	de, hl
		ld	sp, hl		; SP auf SP0 setzen
		ld	bc, COLD1
		jp	NEXT		; weiter mit COLD


;------------------------------------------------------------------------------
; BYE
; : BYE   SAVE-BUFFERS 12 OS ;
;------------------------------------------------------------------------------

		header	BYE, "BYE", DOCOL

		dw SAVEBUF
		dw XLIT
		dw 0Ch			; Offset Systemaufruf BYE
		dw OS
		dw UNNEST

;------------------------------------------------------------------------------
; ?CONDITION
; : ?CONDITION   = NOT ABORT" Conditionals wrong" ;
;------------------------------------------------------------------------------

		header	QCOND, "?CONDITION", DOCOL

		dw EQUAL
		dw NOTT
		dw XABORT
		db 18,"Conditionals wrong"
		dw UNNEST

;------------------------------------------------------------------------------
; >MARK
; : >MARK   HERE 0 , ;
;------------------------------------------------------------------------------

		header	TOMARK, ">MARK", DOCOL

		dw HERE
		dw ZERO
		dw COMMA
		dw UNNEST

;------------------------------------------------------------------------------
; <MARK
; : <MARK   HERE ;
;------------------------------------------------------------------------------

		header	FROMMARK, "<MARK", DOCOL

		dw HERE
		dw UNNEST

;------------------------------------------------------------------------------
; >RESOLVE
; : >RESOLVE   HERE SWAP ! ;
;------------------------------------------------------------------------------

		header	TORESOLV, ">RESOLVE", DOCOL

		dw HERE
		dw SWAP
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; <RESOLVE
; : <RESOLVE   , ;
;------------------------------------------------------------------------------

		header	FROMRESOLV, "<RESOLVE", DOCOL

		dw COMMA
		dw UNNEST

;------------------------------------------------------------------------------
; ?>RESOLVE
; : ?>RESOLVE   ?CONDITION >RESOLVE ;
;------------------------------------------------------------------------------

		header	QTORESOLV, "?>RESOLVE", DOCOL

		dw QCOND
		dw TORESOLV
		dw UNNEST

;------------------------------------------------------------------------------
; ?<RESOLVE
; : ?<RESOLVE   ?CONDITION <RESOLVE ;
;------------------------------------------------------------------------------

		header	QFROMRESOLV, "?<RESOLVE", DOCOL

		dw QCOND
		dw FROMRESOLV
		dw UNNEST

;------------------------------------------------------------------------------
; LEAVE
; : LEAVE   COMPILE (LEAVE) ; IMMEDIATE
;------------------------------------------------------------------------------

		header	LEAVE, "LEAVE", DOCOL, IMMEDIATE

		dw COMPILE
		dw XLEAVE
		dw UNNEST

;------------------------------------------------------------------------------
; ?LEAVE
; : ?LEAVE   COMPILE (?LEAVE) ; IMMEDIATE
;------------------------------------------------------------------------------

		header	QLEAVE, "?LEAVE", DOCOL, IMMEDIATE

		dw COMPILE
		dw XQLEAVE
		dw UNNEST

;------------------------------------------------------------------------------
; BEGIN
; : BEGIN   <MARK TRUE ; IMMEDIATE
;------------------------------------------------------------------------------

		header	BEGIN, "BEGIN", DOCOL, IMMEDIATE

		dw FROMMARK
		dw TRUEE
		dw UNNEST

;------------------------------------------------------------------------------
; THEN
; : THEN   FALSE ?>RESOLVE ; IMMEDIATE
;------------------------------------------------------------------------------

		header	THEN, "THEN", DOCOL, IMMEDIATE

		dw FALSEE
		dw QTORESOLV
		dw UNNEST

;------------------------------------------------------------------------------
; DO
; : DO   COMPILE (DO) >MARK 1 ; IMMEDIATE
;------------------------------------------------------------------------------

		header	DO, "DO", DOCOL, IMMEDIATE

		dw COMPILE
		dw XDO
		dw TOMARK
		dw ONE
		dw UNNEST

;------------------------------------------------------------------------------
; ?DO
; : ?DO   COMPILE (?DO) >MARK 1 ; IMMEDIATE
;------------------------------------------------------------------------------

		header	QDO, "?DO", DOCOL, IMMEDIATE

		dw COMPILE
		dw XQDO
		dw TOMARK
		dw ONE
		dw UNNEST

;------------------------------------------------------------------------------
; LOOP
; : LOOP   COMPILE (LOOP) OVER 2+ OVER 1 ?<RESOLVE 1 ?>RESOLVE ; IMMEDIATE
;------------------------------------------------------------------------------

		header	LOOP, "LOOP", DOCOL, IMMEDIATE

		dw COMPILE
		dw XLOOP
		dw OVER
		dw TWOP
		dw OVER
		dw ONE
		dw QFROMRESOLV
		dw ONE
		dw QTORESOLV
		dw UNNEST

;------------------------------------------------------------------------------
; +LOOP
; : +LOOP   COMPILE (+LOOP) OVER 2+ OVER 1 ?<RESOLVE 1 ?>RESOLVE ; IMMEDIATE
;------------------------------------------------------------------------------

		header	PLOOP, "+LOOP", DOCOL, IMMEDIATE

		dw COMPILE
		dw XPLOOP
		dw OVER
		dw TWOP
		dw OVER
		dw ONE
		dw QFROMRESOLV
		dw ONE
		dw QTORESOLV
		dw UNNEST

;------------------------------------------------------------------------------
; UNTIL
; : UNTIL   COMPILE ?BRANCH TRUE ?<RESOLVE ; IMMEDIATE
;------------------------------------------------------------------------------

		header	UNTIL, "UNTIL", DOCOL, IMMEDIATE

		dw COMPILE
		dw QBRANCH
		dw TRUEE
		dw QFROMRESOLV
		dw UNNEST

;------------------------------------------------------------------------------
; AGAIN
; : AGAIN   COMPILE BRANCH TRUE ?<RESOLVE ; IMMEDIATE
;------------------------------------------------------------------------------

		header	AGAIN, "AGAIN", DOCOL, IMMEDIATE

		dw COMPILE
		dw BRANCH
		dw TRUEE
		dw QFROMRESOLV
		dw UNNEST

;------------------------------------------------------------------------------
; REPEAT
; : REPEAT   2SWAP [COMPILE] AGAIN [COMPILE] THEN ; IMMEDIATE
;------------------------------------------------------------------------------

		header	REPEAT, "REPEAT", DOCOL, IMMEDIATE

		dw TSWAP
		dw AGAIN
		dw THEN
		dw UNNEST

;------------------------------------------------------------------------------
; IF
; : IF   COMPILE ?BRANCH >MARK FALSE ; IMMEDIATE
;------------------------------------------------------------------------------

		header	IFF, "IF", DOCOL, IMMEDIATE

		dw COMPILE
		dw QBRANCH
		dw TOMARK
		dw FALSEE
		dw UNNEST

;------------------------------------------------------------------------------
; ELSE
; : ELSE   COMPILE BRANCH >MARK FALSE SWAP FALSE ?>RESOLVE ; IMMEDIATE
;------------------------------------------------------------------------------

		header	ELSE, "ELSE", DOCOL, IMMEDIATE

		dw COMPILE
		dw BRANCH
		dw TOMARK
		dw FALSEE
		dw TSWAP
		dw FALSEE
		dw QTORESOLV
		dw UNNEST

;------------------------------------------------------------------------------
; WHILE
; : WHILE   [COMPILE] IF ; IMMEDIATE
;------------------------------------------------------------------------------

		header	WHILE, "WHILE", DOCOL, IMMEDIATE

		dw IFF
		dw UNNEST

;------------------------------------------------------------------------------
; ?
; : ?   @ . ;
;------------------------------------------------------------------------------

		header	QUEST, "?", DOCOL

		dw AT
		dw DOT
		dw UNNEST

;------------------------------------------------------------------------------
; ASCII
; : ASCII   BL WORD 1+ C@ STATE @ IF [COMPILE] LITERAL THEN ; IMMEDIATE
;------------------------------------------------------------------------------

		header	ASCII, "ASCII", DOCOL, IMMEDIATE

		dw BL
		dw WORD
		dw ONEP
		dw CAT
		dw STATE
		dw AT
		dw QBRANCH
		dw off_23C4
		dw LITERAL
off_23C4:	dw UNNEST

;------------------------------------------------------------------------------
; CONTROL
; : CONTROL   BL WORD 1+ C@ 31 AND STATE @ IF [COMPILE] LITERAL THEN ; IMMEDIATE
;------------------------------------------------------------------------------

		header	CONTROL, "CONTROL", DOCOL, IMMEDIATE

		dw BL
		dw WORD
		dw ONEP
		dw CAT
		dw XLIT
		dw 1Fh
		dw ANDD
		dw STATE
		dw AT
		dw QBRANCH
		dw off_23EA
		dw LITERAL
off_23EA:	dw UNNEST

;------------------------------------------------------------------------------
; DEPTH
; : DEPTH   SP@ SP0 @ SWAP - 2/ ;
;------------------------------------------------------------------------------

		header	DEPTH, "DEPTH", DOCOL

		dw SPAT
		dw SPZ
		dw AT
		dw SWAP
		dw MINUS
		dw TDIVIDE
		dw UNNEST

;------------------------------------------------------------------------------
; .S
; : .S   CR DEPTH ?DUP IF 0 DO DEPTH I - 1- PICK 7 U.R SPACE LOOP 
;    ELSE ." empty " THEN ;
;------------------------------------------------------------------------------

		header	DOTS, ".S", DOCOL

		dw CR
		dw DEPTH
		dw QDUPP
		dw QBRANCH
		dw off_2435
		dw ZERO
		dw XDO
		dw off_2431
off_241B:	dw DEPTH
		dw IDO
		dw MINUS
		dw ONEM
		dw PICK
		dw XLIT
		dw 7
		dw UDOTR
		dw SPACE
		dw XLOOP
		dw off_241B
off_2431:	dw BRANCH
		dw off_243E
off_2435:	dw XDOTQ
		db 6,"empty "
off_243E:	dw UNNEST

;------------------------------------------------------------------------------
; ?ENOUGH
; : ?ENOUGH   DEPTH 1- > (ABORT") not enough parameters" ;
;------------------------------------------------------------------------------

		header	QENOUGH, "?ENOUGH", DOCOL

		dw DEPTH
		dw ONEM
		dw GREAT
		dw XABORT
		db 21,"not enough parameters"
		dw UNNEST

;------------------------------------------------------------------------------
; RMARGIN
; VARIABLE RMARGIN
; ( z1013) 28 RMARGIN !
;------------------------------------------------------------------------------

		header	RMARGIN, "RMARGIN", DOVAR

		if sysver == "Z1013"
		dw 28
		elseif sysver == "Z9001"
		dw 36
		elseif sysver == "BIC"
		dw 70
		endif

;------------------------------------------------------------------------------
; ?LINE
; : ?LINE   #OUT @ + RMARGIN @ > IF CR THEN ;
;------------------------------------------------------------------------------

		header	QLINE, "?LINE", DOCOL

		dw NOUT
		dw AT
		dw PLUS
		dw RMARGIN
		dw AT
		dw GREAT
		dw QBRANCH
		dw off_2496
		dw CR
off_2496:	dw UNNEST

;------------------------------------------------------------------------------
; .ID
; HEX : .ID   DUP 1+ DUP C@ ROT C@ 1F AND 0
;   ?DO DUP 7F AND EMIT 80 AND IF 0DFh ( ASCII _ or 80) ELSE 1+ DUP C@ THEN
;   LOOP 2DROP SPACE ;
;------------------------------------------------------------------------------

		header	DOTID, ".ID", DOCOL

		dw DUPP
		dw ONEP
		dw DUPP
		dw CAT
		dw ROT
		dw CAT
		dw XLIT
		dw 1Fh
		dw ANDD
		dw ZERO
		dw XQDO
		dw off_24DE
off_24B8:	dw DUPP
		dw XLIT
		dw 7Fh
		dw ANDD
		dw EMIT
		dw XLIT
		dw 80h
		dw ANDD
		dw QBRANCH
		dw off_24D4
		dw XLIT
		dw 0DFh
		dw BRANCH
		dw off_24DA
off_24D4:	dw ONEP
		dw DUPP
		dw CAT
off_24DA:	dw XLOOP
		dw off_24B8
off_24DE:	dw TDROP
		dw SPACE
		dw UNNEST

;------------------------------------------------------------------------------
; LARGEST
; : LARGEST   OVER 0 SWAP ROT 0 
;    DO 2DUP @ U< IF -ROT 2DROP DUP @ OVER THEN 2+ LOOP DROP ;
;------------------------------------------------------------------------------

		header	LARGEST, "LARGEST", DOCOL

		dw OVER
		dw ZERO
		dw SWAP
		dw ROT
		dw ZERO
		dw XDO
		dw off_2518
off_24FE:	dw TDUPP
		dw AT
		dw ULESS
		dw QBRANCH
		dw off_2512
		dw MROT
		dw TDROP
		dw DUPP
		dw AT
		dw OVER
off_2512:	dw TWOP
		dw XLOOP
		dw off_24FE
off_2518:	dw DROP
		dw UNNEST

;------------------------------------------------------------------------------
; WORDS
; HEX : WORDS   CR CONTEXT @ HERE #THREADS 2* CMOVE 
;   BEGIN HERE #THREADS LARGEST DUP 
;   WHILE DUP L>NAME DUP C@ 1F AND ?LINE .ID SPACE SPACE @ SWAP ! 
;   KEY? IF EXIT THEN REPEAT 2DROP ;
;------------------------------------------------------------------------------

		header	WORDS, "WORDS", DOCOL

		dw CR
		dw CONTEXT
		dw AT
		dw HERE
		dw NUMTHREADS
		dw TTIMES
		dw CMOVE
off_2534:	dw HERE
		dw NUMTHREADS
		dw LARGEST
		dw DUPP
		dw QBRANCH
		dw off_2568
		dw DUPP
		dw LTONAME
		dw DUPP
		dw CAT
		dw XLIT
		dw 1Fh
		dw ANDD
		dw QLINE
		dw DOTID
		dw SPACE
		dw SPACE
		dw AT
		dw SWAP
		dw STORE
		dw KEYQ
		dw QBRANCH
		dw off_2564
		dw EXIT
off_2564:	dw BRANCH
		dw off_2534
off_2568:	dw TDROP
		dw UNNEST

;------------------------------------------------------------------------------
; C/L
;------------------------------------------------------------------------------

		header	CPERL, "C/L", DOCON

		if sysver == "Z1013"
		dw 20h
		elseif sysver == "Z9001"
		dw 20h
		elseif sysver == "BIC"
		dw 40h
		endif

;------------------------------------------------------------------------------
; L/SCR
;------------------------------------------------------------------------------

		header	LPERSCR, "L/SCR", DOCON

		dw 10h

;------------------------------------------------------------------------------
; -->
; : -->   >IN OFF 1 BLK +! ; IMMEDIATE
;------------------------------------------------------------------------------

		header	NXTSCR, "-->", DOCOL, IMMEDIATE

		dw TOIN
		dw OFF
		dw ONE
		dw BLK
		dw PLUSSTORE
		dw UNNEST

;------------------------------------------------------------------------------
; LOAD
;  : LOAD   BLK @ >R >IN @ >R >IN OFF BLK ! INTERPRET R> >IN ! R> BLK ! ;
;------------------------------------------------------------------------------

		header	LOAD, "LOAD", DOCOL

		dw BLK
		dw AT
		dw TOR
		dw TOIN
		dw AT
		dw TOR
		dw TOIN
		dw OFF
		dw BLK
		dw STORE
		dw INTRPRT
		dw FROMR
		dw TOIN
		dw STORE
		dw FROMR
		dw BLK
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; THRU
; : THRU   2 ?ENOUGH 1+ SWAP DO I LOAD LOOP ;
;------------------------------------------------------------------------------

		header	THRU, "THRU", DOCOL

		dw TWO
		dw QENOUGH
		dw ONEP
		dw SWAP
		dw XDO
		dw off_25E0
off_25D8:	dw IDO
		dw LOAD
		dw XLOOP
		dw off_25D8
off_25E0:	dw UNNEST

;------------------------------------------------------------------------------
; LIST
; : LIST   1 ?ENOUGH CR DUP SCR ! ." Scr # " DUP . L/SCR 0 
;    DO CR I 3 .R SPACE DUP BLOCK I C/L * + C/L -TRAILING >TYPE 
;    KEY? ?LEAVE LOOP DROP CR ;
;------------------------------------------------------------------------------

		header	LIST, "LIST", DOCOL

		dw ONE
		dw QENOUGH
		dw CR
		dw DUPP
		dw SCR
		dw STORE
		dw XDOTQ
		db 6,"Scr # "
		dw DUPP
		dw DOT
		dw LPERSCR
		dw ZERO
		dw XDO
		dw off_2630
off_260C:	dw CR
		dw IDO
		dw THREE
		dw DOTR
		dw SPACE
		dw DUPP
		dw BLOCK
		dw IDO
		dw CPERL
		dw STAR
		dw PLUS
		dw CPERL
		dw MTRAILING
		dw TOTYPE
		dw KEYQ
		dw XQLEAVE
		dw XLOOP
		dw off_260C
off_2630:	dw DROP
		dw CR
		dw UNNEST

;------------------------------------------------------------------------------
; INDEX
; : INDEX   2 ?ENOUGH 1+ SWAP 
;    DO CR I 3 .R SPACE I BLOCK C/L -TRAILING >TYPE 
;    KEY? ?LEAVE LOOP CR ;
;------------------------------------------------------------------------------

		header	INDEX, "INDEX", DOCOL

		dw TWO
		dw QENOUGH
		dw ONEP
		dw SWAP
		dw XDO
		dw off_2668
off_264C:	dw CR
		dw IDO
		dw THREE
		dw DOTR
		dw SPACE
		dw IDO
		dw BLOCK
		dw CPERL
		dw MTRAILING
		dw TOTYPE
		dw KEYQ
		dw XQLEAVE
		dw XLOOP
		dw off_264C
off_2668:	dw CR
		dw UNNEST

;------------------------------------------------------------------------------
; \
; : \   >IN @ NEGATE C/L MOD >IN +! ; IMMEDIATE
;------------------------------------------------------------------------------

		header	COMMENT2, "\\", DOCOL, IMMEDIATE

		dw TOIN
		dw AT
		dw NEGATE
		dw CPERL
		dw MOD
		dw TOIN
		dw PLUSSTORE
		dw UNNEST

;------------------------------------------------------------------------------
; \S
; : \S   B/BUF >IN ! ; IMMEDIATE
;------------------------------------------------------------------------------

		header	CSCREEN, "\\S", DOCOL, IMMEDIATE

		dw BBUF
		dw TOIN
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; FH
; : FH   BLK @ + ;
;------------------------------------------------------------------------------

		header	FH, "FH", DOCOL

		dw BLK
		dw AT
		dw PLUS
		dw UNNEST

;------------------------------------------------------------------------------
; COPY
; : COPY   2 ?ENOUGH SWAP BLOCK DROP BLK# ! UPDATE SAVE-BUFFERS ;
;------------------------------------------------------------------------------

		header	COPY, "COPY", DOCOL

		dw TWO
		dw QENOUGH
		dw SWAP
		dw BLOCK
		dw DROP
		dw BLKNUM
		dw STORE
		dw UPDATE
		dw SAVEBUF
		dw UNNEST

;------------------------------------------------------------------------------
; P@
;------------------------------------------------------------------------------

		header	PAT, "P@"

		pop	de
		ld	h, c
		ld	c, e
		in	l, (c)
		ld	c, h
		ld	h, 0
		jp	HPUSH

;------------------------------------------------------------------------------
; P!
;------------------------------------------------------------------------------

		header	PSTOR, "P!"

		pop	de
		ld	h, c
		ld	c, e
		pop	de
		out	(c), e
		ld	c, h
		jp	NEXT

;------------------------------------------------------------------------------
; ROOT
; VOCABULARY ROOT
;------------------------------------------------------------------------------

		header	VROOT, "ROOT", DOVOC

off_26E9:	dw lstlnk_14
		dw lstlnk_15
		dw lstlnk_16
		dw lstlnk_17
VROOTL:		dw VUSERL

;------------------------------------------------------------------------------
; ALSO
; ROOT DEFINITIONS
; : ALSO   CONTEXT DUP 2+ #VOCS 2- 2* CMOVE> ;
;------------------------------------------------------------------------------

		voc ROOT
		header	ALSO, "ALSO", DOCOL

		dw CONTEXT
		dw DUPP
		dw TWOP
		dw VOCS
		dw TWOM
		dw TTIMES
		dw CMOVETO
		dw UNNEST

;------------------------------------------------------------------------------
; ONLY
; : ONLY   ['] ROOT >BODY CONTEXT #VOCS 1- 2* 2DUP ERASE + ! ROOT ;
;------------------------------------------------------------------------------

		header	ONLY, "ONLY", DOCOL

		dw XLIT
		dw VROOT
		dw TOBODY
		dw CONTEXT
		dw VOCS
		dw ONEM
		dw TTIMES
		dw TDUPP
		dw ERASE
		dw PLUS
		dw STORE
		dw VROOT
		dw UNNEST

;------------------------------------------------------------------------------
; SEAL
; : SEAL   ' >BODY CONTEXT #VOCS 2* ERASE CONTEXT ! ;
;------------------------------------------------------------------------------

		header	SEAL, "SEAL", DOCOL

		dw TICK
		dw TOBODY
		dw CONTEXT
		dw VOCS
		dw TTIMES
		dw ERASE
		dw CONTEXT
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; PREVIOUS
; : PREVIOUS   CONTEXT DUP 2+ SWAP #VOCS 2- 2* CMOVE 
;    CONTEXT #VOCS 2- 2* + OFF ;
;------------------------------------------------------------------------------

		header	PREVIOUS, "PREVIOUS", DOCOL

		dw CONTEXT
		dw DUPP
		dw TWOP
		dw SWAP
		dw VOCS
		dw TWOM
		dw TTIMES
		dw CMOVE
		dw CONTEXT
		dw VOCS
		dw TWOM
		dw TTIMES
		dw PLUS
		dw OFF
		dw UNNEST

;------------------------------------------------------------------------------
; FORTH
; : FORTH   FORTH ;
;------------------------------------------------------------------------------

		header	FORTH, "FORTH", DOCOL

		dw VFORTH
		dw UNNEST

;------------------------------------------------------------------------------
; DEFINITIONS
; : DEFINITIONS   DEFINITIONS ;
;------------------------------------------------------------------------------

		header	DEFINITIONS, "DEFINITIONS", DOCOL

		dw DEFIN
		dw UNNEST

;------------------------------------------------------------------------------
; ORDER
; : ORDER   CR ." Context: " CONTEXT #VOCS
;    0 DO DUP @ ?DUP IF BODY> >NAME .ID THEN 2+ LOOP DROP 
;    CR ." Current: " CURRENT @ BODY> >NAME .ID ;
;------------------------------------------------------------------------------

		header	ORDER, "ORDER", DOCOL

		dw CR
		dw XDOTQ
		db 9,"Context: "
		dw CONTEXT
		dw VOCS
		dw ZERO
		dw XDO
		dw off_27CF
off_27B9:	dw DUPP
		dw AT
		dw QDUPP
		dw QBRANCH
		dw off_27C9
		dw FROMBODY
		dw TONAME
		dw DOTID
off_27C9:	dw TWOP
		dw XLOOP
		dw off_27B9
off_27CF:	dw DROP
		dw CR
		dw XDOTQ
		db 9,"Current: "
		dw CURRENT
		dw AT
		dw FROMBODY
		dw TONAME
		dw DOTID
		dw UNNEST

;------------------------------------------------------------------------------
; VOCS
; : VOCS   ." : " VOC-LINK @ BEGIN DUP #THREADS 2* - BODY> >NAME .ID 
;    @ DUP 0= UNTIL DROP ;
;------------------------------------------------------------------------------

		header	VOCS2, "VOCS", DOCOL

		dw XDOTQ
		db 2,": "
		dw VOCLINK
		dw AT
off_27FD:	dw DUPP
		dw NUMTHREADS
		dw TTIMES
		dw MINUS
		dw FROMBODY
		dw TONAME
		dw DOTID
		dw AT
		dw DUPP
		dw ZEQU
		dw QBRANCH
		dw off_27FD
		dw DROP
		dw UNNEST

;------------------------------------------------------------------------------
; WORDS
; : WORDS   WORDS ;
;------------------------------------------------------------------------------

		header	WORDS2, "WORDS", DOCOL

		dw WORDS
		dw UNNEST

;------------------------------------------------------------------------------
; HELLO
; FORTH DEFINITIONS
; : HELLO   EMPTY-BUFFERS ONLY FORTH ALSO DEFINITIONS DECIMAL .PROCLAIM ;
;------------------------------------------------------------------------------

		voc FORTH
		header	HELLO, "HELLO", DOCOL

		dw EMPTYBUF
		dw ONLY
		dw FORTH
		dw ALSO
		dw DEFINITIONS
		dw DECIMAL
		if sysver == "Z1013"
		dw PPROCLAIM
		elseif sysver == "Z9001"
		dw PPROCLAIM
		elseif sysver == "BIC"
		dw PVERSION
		endif
		dw UNNEST

;------------------------------------------------------------------------------
; /LINE
; VARIABLE /LINE 
; ( z1013) 4 /LINE !
;------------------------------------------------------------------------------

		header	SLINE, "/LINE", DOVAR

		if sysver == "Z1013"
		dw 4
		elseif sysver == "Z9001"
		dw 8
		elseif sysver == "BIC"
		dw 16
		endif

;------------------------------------------------------------------------------
; .2
; : .2   0 <# # # #> TYPE SPACE ;
;------------------------------------------------------------------------------

		header	DOTTWO, ".2", DOCOL

		dw ZERO
		dw BDIGS
		dw DIG
		dw DIG
		dw EDIGS
		dw TYPE
		dw SPACE
		dw UNNEST

;------------------------------------------------------------------------------
; DUMP
; HEX : DUMP   BASE @ >R HEX CR CR 
;    5 SPACES /LINE @ 0 DO I 3 .R LOOP
;    2 SPACES /LINE @ 0 DO I 1 .R LOOP CR 
;    OVER + SWAP /LINE @ NEGATE AND 
;    DO CR I 4 U.R SPACE SPACE I /LINE @ + I 2DUP 
;      DO I C@ .2 LOOP SPACE 
;      DO I C@ DUP BL 7E BETWEEN NOT IF DROP ASCII . THEN EMIT LOOP
;      KEY? ?LEAVE /LINE @ +LOOP CR R> BASE ! ;
;------------------------------------------------------------------------------

		header	DUMP, "DUMP", DOCOL

		dw BASE
		dw AT
		dw TOR
		dw HEX
		dw CR
		dw CR
		dw XLIT
		dw 5
		dw SPACES
		dw SLINE
		dw AT
		dw ZERO
		dw XDO
		dw off_2893
off_2889:	dw IDO
		dw THREE
		dw DOTR
		dw XLOOP
		dw off_2889
off_2893:	dw TWO
		dw SPACES
		dw SLINE
		dw AT
		dw ZERO
		dw XDO
		dw off_28AB
off_28A1:	dw IDO
		dw ONE
		dw DOTR
		dw XLOOP
		dw off_28A1
off_28AB:	dw CR
		dw OVER
		dw PLUS
		dw SWAP
		dw SLINE
		dw AT
		dw NEGATE
		dw ANDD
		dw XDO
		dw off_2919
off_28BF:	dw CR
		dw IDO
		dw XLIT
		dw 4
		dw UDOTR
		dw SPACE
		dw SPACE
		dw IDO
		dw SLINE
		dw AT
		dw PLUS
		dw IDO
		dw TDUPP
		dw XDO
		dw off_28E7
off_28DD:	dw IDO
		dw CAT
		dw DOTTWO
		dw XLOOP
		dw off_28DD
off_28E7:	dw SPACE
		dw XDO
		dw off_290D
off_28ED:	dw IDO
		dw CAT
		dw DUPP
		dw BL
		dw XLIT
		dw 7Eh
		dw BETWEEN
		dw NOTT
		dw QBRANCH
		dw off_2907
		dw DROP
		dw XLIT
		dw 2Eh
off_2907:	dw EMIT
		dw XLOOP
		dw off_28ED
off_290D:	dw KEYQ
		dw XQLEAVE
		dw SLINE
		dw AT
		dw XPLOOP
		dw off_28BF
off_2919:	dw CR
		dw FROMR
		dw BASE
		dw STORE
		dw UNNEST

;------------------------------------------------------------------------------
; DU
; HEX : DU   DUP 3F DUMP 40 + ;
;------------------------------------------------------------------------------

		header	DU, "DU", DOCOL

		dw DUPP
		dw XLIT
		dw 3Fh
		dw DUMP
		dw XLIT
		dw 40h
		dw PLUS
		dw UNNEST

;------------------------------------------------------------------------------
; PUT
; DEFER PUT
; ' CRASH IS PUT
;------------------------------------------------------------------------------

		header	PUT, "PUT", DOVEC

	if sysver == "BIC"
		dw XPUT
	else		
		dw CRASH
	endif

;------------------------------------------------------------------------------
; GET
; DEFER GET
; ' CRASH IS GET
;------------------------------------------------------------------------------

		header	GET, "GET", DOVEC

	if sysver == "BIC"
		dw CGET
	else		
		dw CRASH
	endif

;------------------------------------------------------------------------------
; MARK
; : MARK   CREATE DOES> (FORGET) FORTH DEFINITIONS ;
;------------------------------------------------------------------------------

		header	MARK, "MARK", DOCOL

		dw CREATE
		dw XSCODE
;
DOMARK:		call	DODOE
		dw XFORGET
		dw FORTH
		dw DEFINITIONS
		dw UNNEST




; ab hier individuelle Anpassung an Z1013


	if sysver == "Z1013"

;------------------------------------------------------------------------------
; LMARGIN
; VARIABLE LMARGIN   8 LMARGIN !
;------------------------------------------------------------------------------

		header	LMARGIN, "LMARGIN", DOVAR

		dw 8

;------------------------------------------------------------------------------
; (CR)
; : (CR)   CRLF PRINTING @ IF LMARGIN @ 0 DO BL (PRINT) LOOP THEN ;
; ' (CR) IS CR
;------------------------------------------------------------------------------

		voc IO
		header	XCR, "(CR)", DOCOL

		dw CRLF
		dw PRINTING
		dw AT
		dw QBRANCH
		dw XCR2
		dw LMARGIN
		dw AT
		dw ZERO
		dw XDO
		dw XCR2
XCR1:		dw BL
		dw XPRINT
		dw XLOOP
		dw XCR1
XCR2:		dw UNNEST

;------------------------------------------------------------------------------
; .PROCLAIM
; : .PROCLAIM   12 EMIT  ." Z80 FORTH 1.3 (Z1013)" CR  ." AG FORTH" CR
; ." Th. Beierlein / "  ." A. Driesel" CR ;
;------------------------------------------------------------------------------

		voc FORTH
		header	PPROCLAIM, ".PROCLAIM", DOCOL

		dw XLIT
		dw 0Ch
		dw EMIT
		dw XDOTQ
		db 21,"Z80 FORTH 1.3 (Z1013)"
		dw CR
		dw XDOTQ
		db 8,"AG FORTH"
		dw CR
		dw XDOTQ
		db 16,"Th. Beierlein / "
		dw XDOTQ
		db 10,"A. Driesel"
		dw CR
		dw UNNEST

;------------------------------------------------------------------------------
; EMPTY
; MARK EMPTY  HERE FENCE !
;------------------------------------------------------------------------------

		header	EMPTY, "EMPTY", DOMARK


; ab hier individuelle Anpassung an Z9001


	elseif sysver == "Z9001"

;------------------------------------------------------------------------------
; LMARGIN
; VARIABLE LMARGIN   8 LMARGIN !
;------------------------------------------------------------------------------

		header	LMARGIN, "LMARGIN", DOVAR

		dw 8

;------------------------------------------------------------------------------
; (CR)
; : (CR)   CRLF PRINTING @ IF LMARGIN @ 0 DO BL (PRINT) LOOP THEN ;
; ' (CR) IS CR
;------------------------------------------------------------------------------

		voc IO
		header	XCR, "(CR)", DOCOL

		dw CRLF
		dw PRINTING
		dw AT
		dw QBRANCH
		dw XCR2
		dw LMARGIN
		dw AT
		dw ZERO
		dw XDO
		dw XCR2
XCR1:		dw BL
		dw XPRINT
		dw XLOOP
		dw XCR1
XCR2:		dw UNNEST

;------------------------------------------------------------------------------
; .PROCLAIM
; : .PROCLAIM   12 EMIT  ." Z80 FORTH 1.3 (Z9001)" CR  ." AG FORTH" CR
; ." Th. Beierlein / "  ." V. Pohlers" CR ;
;------------------------------------------------------------------------------

		voc FORTH
		header	PPROCLAIM, ".PROCLAIM", DOCOL

		dw XLIT
		dw 0Ch
		dw EMIT
		dw XDOTQ
		db 21,"Z80 FORTH 1.3 (Z9001)"
		dw CR
		dw XDOTQ
		db 8,"AG FORTH"
		dw CR
		dw XDOTQ
		db 16,"Th. Beierlein / "
		dw XDOTQ
		db 10,"V. Pohlers"
		dw CR
		dw UNNEST

;------------------------------------------------------------------------------
; EMPTY
; MARK EMPTY  HERE FENCE !
;------------------------------------------------------------------------------

		header	EMPTY, "EMPTY", DOMARK



; ab hier individuelle Anpassung an CPM


	elseif sysver == "BIC"

;		voc FORTH
;		header	EMPTY, "EMPTY", DOMARK
		include	f83_aigv13_teil2.asm		
	
	endif	


eof:		equ	$


;------------------------------------------------------------------------------
; Makro fr Vokabulare
; die aktuellen Link-Adressen werden in je 4 Variablen lstlnk_xxx vorgehalten
; und in die Vokabular-Listen bernommen

cnt		eval	0
		REPT	28
lcharx		eval 	"edlnk_\{cnt}"
lstlnk		eval 	"lstlnk_\{cnt}"
		IFNDEF {lcharx}
{lcharx}	eval	0
		endif
{lstlnk}	equ	{lcharx}
cnt		eval	cnt+1
		ENDM
				
;------------------------------------------------------------------------------
		end
